Attribute VB_Name = "Deklarationen"
Option Explicit

Public Declare Function ShowCursor Lib "user32" (ByVal _
        bShow As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliSeconds As Long)
Public Declare Function GetTickCount Lib "kernel32" () As Long
       
Public Declare Function EnumDisplaySettings Lib "user32" _
        Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName _
        As Long, ByVal iModeNum As Long, lpDevMode As Any) _
        As Boolean
        
Public Declare Function ChangeDisplaySettings Lib "user32" _
        Alias "ChangeDisplaySettingsA" (lpDevMode As Any, _
        ByVal dwFlags As Long) As Long

Public Const CCDEVICENAME As Long = 32&
Public Const CCFORMNAME As Long = 32&
Public Const DM_BITSPERPEL As Long = &H40000
Public Const DM_PELSWIDTH As Long = &H80000
Public Const DM_PELSHEIGHT As Long = &H100000
Public Const CDS_UPDATEREGISTRY As Long = &H1&
Public Const CDS_TEST As Long = &H4&
Public Const DISP_CHANGE_SUCCESSFUL As Long = 0&
Public Const DISP_CHANGE_RESTART As Long = 1&
Public Const ENUM_CURRENT_SETTINGS As Long = -1&
Public Const DM_DISPLAYFREQUENCY As Long = &H400000

Public Type DEVMODE
    dmDeviceName As String * CCDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type
       
Public Dx As DirectX8
Public D3D As Direct3D8
Public D3DDevice As Direct3DDevice8
Public D3DX As D3DX8

Public DS As DirectSound8
Public DSEnum As DirectSoundEnum8
Public DSBDesc As DSBUFFERDESC

Public Configs(6) As String
Public Const Version As String = "Version 1.0"
Public s_Version As String

Public DSAudio As IBasicAudio
Public DSEvent As IMediaEvent
Public DSControl As IMediaControl
Public DSPosition As IMediaPosition

Public matWorld As D3DMATRIX
Public matView As D3DMATRIX
Public matProj As D3DMATRIX
Public matTemp As D3DMATRIX

Public DispMode As D3DDISPLAYMODE
Public D3DWindow As D3DPRESENT_PARAMETERS

Public Const Lit_FVF = (D3DFVF_XYZ Or D3DFVF_DIFFUSE Or D3DFVF_SPECULAR Or D3DFVF_TEX1)
Public Const pi As Single = 3.14159265358979

Public Type LITVERTEX
    X As Single
    Y As Single
    Z As Single
    color As Long
    Specular As Long
    tu As Single
    tv As Single
End Type

Public FPS_LastCheck As Long
Public FPS_Count As Long
Public FPS_Highest As Long
Public FPS_Current As Integer

Public Scroll_Color_Start(4) As Single
Public Credits_Color_Start(6) As Single
Public Scroll_Over_Start(4) As Boolean
Public Groundebene_shop(0 To 1, 0 To 3) As Integer

Public ebene As Integer
Public Groundebene As Integer

Public Scroll_Color_Main(19) As Single
Public Scroll_Over_Main(19) As Boolean
Public Ground_Shop(1, 3) As Single
Public Board As Single

Public Ground_color As Single, Activeebene As Integer
Public Activeebene_shop(0 To 1, 0 To 3) As Integer

Public POSITION As String
Public Ende As Single

'##############################levels
Public vbuffer_terrain As Direct3DVertexBuffer8
Public vbuffer_waves As Direct3DVertexBuffer8
Public vbuffer_flora As Direct3DVertexBuffer8
Public vbuffer_himmel_links As Direct3DVertexBuffer8
Public vbuffer_himmel_rechts As Direct3DVertexBuffer8
Public vbuffer_menue As Direct3DVertexBuffer8
Public vbuffer_menue2 As Direct3DVertexBuffer8
Public vbuffer_menue_primary As Direct3DVertexBuffer8
Public vbuffer_menue_energy As Direct3DVertexBuffer8
Public vbuffer_menue_pause As Direct3DVertexBuffer8
Public vbuffer_menue_sieg As Direct3DVertexBuffer8
Public vbuffer_menue_neigung As Direct3DVertexBuffer8
Public vbuffer_menue_extra1 As Direct3DVertexBuffer8
Public vbuffer_menue_extra2 As Direct3DVertexBuffer8
Public vbuffer_menue_extra3 As Direct3DVertexBuffer8
Public vbuffer_MovieStrips As Direct3DVertexBuffer8
Public vbuffer_Shot(5, 100) As Direct3DVertexBuffer8
Public vbuffer_Smoke(100) As Direct3DVertexBuffer8
Public VBuffer_Explosion1(100) As Direct3DVertexBuffer8
Public VBuffer_Explosion2(100) As Direct3DVertexBuffer8
Public VBuffer_Explosion3(100) As Direct3DVertexBuffer8
Public VBuffer_Treffer_Links(100) As Direct3DVertexBuffer8
Public VBuffer_Treffer_Rechts(100) As Direct3DVertexBuffer8
Public VBuffer_Shockwave(2, 100) As Direct3DVertexBuffer8

Public Texture(4) As Direct3DTexture8
Public Texture2 As Direct3DTexture8
Public Texture3 As Direct3DTexture8
Public Texture_himmel As Direct3DTexture8
Public Texture_menue As Direct3DTexture8
Public Texture_menue2 As Direct3DTexture8
Public Texture_Pause(2) As Direct3DTexture8
Public Texture_stats As Direct3DTexture8
Public Texture_energy(5) As Direct3DTexture8
Public Texture_neigung As Direct3DTexture8
Public Texture_Shot(5) As Direct3DTexture8
Public Texture_Weapon(4) As Direct3DTexture8
Public Texture_Extras(-1 To 7) As Direct3DTexture8
Public Texture_Shockwave As Direct3DTexture8

Public Lights(0 To 1) As D3DLIGHT8

Public Mesh(38) As D3DXMesh
Public MeshMaterials(38, 1000) As D3DMATERIAL8
Public MeshTextures(38, 1000) As Direct3DTexture8
Public nMaterials(38) As Long
Public mtrlBuffer(38) As D3DXBuffer
Public TextureFile(38) As String
      
Public TMenge As Integer
Public TPMenge As Integer

Public Shock(5) As LITVERTEX
Public Partikel(1206) As LITVERTEX
Public PartikelTreffer(1206) As LITVERTEX
Public Himmel_rechts(6) As LITVERTEX
Public Himmel_links(6) As LITVERTEX
Public Terrain(31000) As LITVERTEX
Public Waves(10000) As LITVERTEX
Public Grass(50700) As LITVERTEX
Public TriStrip(0 To 3) As LITVERTEX
Public vShot(0 To 3) As LITVERTEX
Public vSmoke(0 To 3) As LITVERTEX
Public MovieStrip(0 To 11) As LITVERTEX

Public TrefferWay(200) As PartikelCoordinates
Public PartikelWay(200) As PartikelCoordinates
Public PlayerX As Single
Public CurrentActiveLight As Integer
Public LevelMove As Single
Public SetLevel(1) As Long
Public Levelknown As Long
Public Player As PlayerType
Public Repair As Single
Public RepairEinheit As Boolean
Public Primary As PrimaryWeapon
Public Shot(100) As Shot
Public gShot(100) As Shot
Public Rakete(20) As Rocket
Public Smoke(1000) As Smoke
Public SmokePause As Single
Public ShotPause As Single
Public gShotPause(50) As Single
Public DriftPause As Single
Public RaketenPause As Single
Public RaketenNachladen As Single
Public Gegner(50) As enemy
Public Gimmick(50) As gimmicks
Public Explosion(10) As Explosion
Public Shockwave(10) As Shockwave
Public Treffer(10) As Treffer

Public SituationPause As Integer
Public RotateAngle As Single
Public RotatePoint As Integer
Public Triebwerkshitze As Integer
Public Ausweichdsen As Boolean
Public Terragen(-30 To 286, 0 To 256) As Single
Public Tlnge As Long
Public Tbreite As Long
Public Wlnge As Long
Public Wbreite As Long
Public Vlnge As Long
Public Vbreite As Long

Public bRunning As Boolean
Public EscRun As Integer
Public bRun As Boolean
Public bStart As Boolean
Public bSieg As Boolean
Public bTod As Boolean
Public RaketenAuswahl As Integer
Public Gedrckt(255) As Byte

Public Destroyed As Integer
Public DestroyedEnemy As Single
Public Hits As Integer
Public Shoted As Integer
Public HQuote As Single
Public Action As Integer

Public Type PartikelCoordinates
    X As Single
    Y As Single
    Z As Double
End Type

Public Type Explosion
    X As Single
    Y As Single
    Z As Single
    Gone As Single
    Typ As Long
    Blend As Long
End Type

Public Type Shockwave
    X As Single
    Y As Single
    Z As Single
    Gone As Single
    Typ As Long
End Type

Public Type Treffer
    X As Single
    Y As Single
    Z As Single
    Gone As Single
    Typ As Long
    Richtung As Single
End Type

Public Type Shot
    X As Single
    Y As Single
    Z As Single
    vX As Single
    vY As Single
    vZ As Single
    Typ As Long
    Power As Single
    Shoot As Single
    Rotation As Single
End Type

Public Type Rocket
    X As Single
    Y As Single
    Z As Single
    Victim As Integer
    Typ As Long
    Power As Single
    Shoot As Single
End Type

Public Type Smoke
    X As Single
    Y As Single
    Z As Single
    Gone As Single
    Typ As Integer
End Type

Public Type enemy
    X As Single
    Y As Single
    Z As Single
    Typ As Long
    Typsave As Long
    Armor As Single
    Armorsave As Single
    Vibration As Single
    Lifes As Integer
    Richtung As Integer
End Type

Public Type gimmicks
    X As Single
    Y As Single
    Z As Single
    Typ As Long
    Rotation As Single
    RotationZ As Single
End Type
'##############################levels

Public Sub SetScreen(ByVal X As Long, ByVal Y As Long)
    Dim Result As Long
    Dim Dev As DEVMODE
    
    Result = EnumDisplaySettings(0&, ENUM_CURRENT_SETTINGS, Dev)
    If Result <> 0 Then
        Dev.dmDisplayFrequency = 85
        Dev.dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_DISPLAYFREQUENCY
        Dev.dmPelsWidth = X
        Dev.dmPelsHeight = Y
   
        Result = ChangeDisplaySettings(Dev, CDS_TEST)
        ChangeDisplaySettings Dev, CDS_UPDATEREGISTRY

    End If
End Sub

Public Function arcussinus(ByVal X As Double) As Double
    arcussinus = (Atn(X / Sqr(-X * X + 1)) / pi * 180)
End Function


Public Function Crypt(ByVal word As String) As String
    Dim i, Buchstabe As String, Wort As String, Cryptstring As String
    
    Cryptstring = "upgasdhsdfouisdzuathdfahsgdfhafsdhjgasdfgaupgasdhsdfouisdzuathdfahsgdfhafsdhjgasdfga"

    For i = 1 To Len(word)
        Buchstabe = Mid(word, i, 1)
        Wort = Wort & Chr(Asc(Buchstabe) + Asc(Mid(Cryptstring, i, 1)))
    Next i
    
    Crypt = Wort
End Function

Public Function Encrypt(ByVal word As String) As String
    Dim i, Buchstabe As String, Wort As String, Cryptstring As String
    
    Cryptstring = "upgasdhsdfouisdzuathdfahsgdfhafsdhjgasdfgaupgasdhsdfouisdzuathdfahsgdfhafsdhjgasdfga"

    For i = 1 To Len(word)
        Buchstabe = Mid(word, i, 1)
        Wort = Wort & Chr(Asc(Buchstabe) - Asc(Mid(Cryptstring, i, 1)))
    Next i
    
    Encrypt = Wort
End Function

Public Sub Laden(file As String)
On Error Resume Next

    Dim strtemp
    
    Open file & ".egi" For Input As #1
        Line Input #1, strtemp
        s_Version = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Acceleration = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Armor = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Drift = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Energy = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.MaxTempo = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Reactor = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.RocketSlots = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Shild = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Tempo = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.Typ = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Raumschiff.UpdateSlots = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Punkte = CLng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Geld = CLng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_RaketenSlot(0) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_RaketenSlot(1) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_RaketenSlot(2) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_RaketenSlot(3) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_RaketenSlot(4) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_ExtrasSlot(0) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_ExtrasSlot(1) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_ExtrasSlot(2) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Primary.Frequency = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Primary.Power = CSng(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Primary.Typ = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Level = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Schwierigkeitsgrad = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Continue = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(0, 0) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(0, 1) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(0, 2) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(0, 3) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(1, 0) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(1, 1) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(1, 2) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Groundebene_shop(1, 3) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(0, 0) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(0, 1) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(0, 2) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(0, 3) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(1, 0) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(1, 1) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(1, 2) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        Activeebene_shop(1, 3) = CInt(Encrypt(strtemp))
        Line Input #1, strtemp
        s_Highscore = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        RepairEinheit = CStr(Encrypt(strtemp))
    Close 1#
End Sub

Public Function CreateLitVertex(X As Single, Y As Single, Z As Single, Diffuse As Long, Specular As Long, tu As Single, tv As Single) As LITVERTEX
    CreateLitVertex.X = X
    CreateLitVertex.Y = Y
    CreateLitVertex.Z = Z
    CreateLitVertex.color = Diffuse
    CreateLitVertex.Specular = Specular
    CreateLitVertex.tu = tu
    CreateLitVertex.tv = tv
End Function

Public Function MakeVector(X As Single, Y As Single, Z As Single) As D3DVECTOR
    MakeVector.X = X
    MakeVector.Y = Y
    MakeVector.Z = Z
End Function

Public Sub LoadConfigurations()
    Dim strtemp
    Open "options.cfg" For Input As #1
        Line Input #1, strtemp
        Configs(0) = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        Configs(1) = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        Configs(2) = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        Configs(3) = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        Configs(4) = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        Configs(5) = CStr(Encrypt(strtemp))
        Line Input #1, strtemp
        Configs(6) = CStr(Encrypt(strtemp))
    Close 1#
End Sub

Public Function Initialise() As Boolean
    On Error GoTo ErrHandler:
    
    Set Dx = New DirectX8
    Set D3D = Dx.Direct3DCreate()
    Set D3DX = New D3DX8
    Set DSEnum = Dx.GetDSEnum
    
    Call LoadConfigurations
    
    If Mid(Configs(0), 1, 9) = "1280x1024" Then
        Configs(6) = "Save-Render"
    ElseIf Mid(Configs(0), 1, 7) = "800x600" Then
        Configs(6) = "Save-Render"
    ElseIf Mid(Configs(0), 1, 7) = "640x480" Then
        Configs(6) = "Save-Render"
    End If

    If Configs(6) = "Fast-Render" Then
        DispMode.Format = D3DFMT_R5G6B5
        D3DWindow.SwapEffect = D3DSWAPEFFECT_FLIP
        D3DWindow.BackBufferFormat = DispMode.Format
    ElseIf Configs(6) = "Save-Render" Then
        DispMode.Format = D3DFMT_X8R8G8B8
    End If
    
    
    D3DWindow.BackBufferCount = 1
    If Mid(Configs(0), 1, 9) = "1280x1024" Then
        D3DWindow.BackBufferWidth = 1280
        D3DWindow.BackBufferHeight = 1024
    ElseIf Mid(Configs(0), 1, 8) = "1024x768" Then
        D3DWindow.BackBufferWidth = 1024
        D3DWindow.BackBufferHeight = 768
    ElseIf Mid(Configs(0), 1, 7) = "800x600" Then
        D3DWindow.BackBufferWidth = 800
        D3DWindow.BackBufferHeight = 600
    ElseIf Mid(Configs(0), 1, 7) = "640x480" Then
        D3DWindow.BackBufferWidth = 640
        D3DWindow.BackBufferHeight = 480
    End If
    D3DWindow.hDeviceWindow = frmMain.hWnd
    D3DWindow.EnableAutoDepthStencil = 1
    
    If Configs(6) = "Save-Render" Then
        D3DWindow.Windowed = 1
        D3D.GetAdapterDisplayMode D3DADAPTER_DEFAULT, DispMode
        D3DWindow.SwapEffect = D3DSWAPEFFECT_COPY_VSYNC
        D3DWindow.BackBufferFormat = DispMode.Format
    End If
    
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D32) = D3D_OK Then
        If Right(Configs(0), 2) = "32" Then
            D3DWindow.AutoDepthStencilFormat = D3DFMT_D32
        End If
    End If
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D16) = D3D_OK Then
        If Right(Configs(0), 2) = "16" Or D3DWindow.AutoDepthStencilFormat <> D3DFMT_D32 Then
            D3DWindow.AutoDepthStencilFormat = D3DFMT_D16
        End If
    End If
    
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D16) = D3D_OK Then
        Debug.Print "16 bit Z-Buffers are supported (D3DFMT_D16)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D16_LOCKABLE) = D3D_OK Then
        Debug.Print "Lockable 16 bit Z-Buffers are supported (D3DFMT_D16_LOCKABLE)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D24S8) = D3D_OK Then
        Debug.Print "32 bit divided between 24 bit Depth and 8 bit stencil are supported (D3DFMT_D24S8)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D24X4S4) = D3D_OK Then
        Debug.Print "32 bit divided between 24 bit depth, 4 bit stencil and 4 bit unused (D3DFMT_D24X4S4)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D24X8) = D3D_OK Then
        Debug.Print "24 bit Z-Buffer supported (D3DFMT_D24X8)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D32) = D3D_OK Then
        Debug.Print "Pure 32 bit Z-buffer supported (D3DFMT_D32)"
    End If
    
    If Configs(1) = "Software" Then
        Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, frmMain.hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, D3DWindow)
    ElseIf Configs(1) = "Mixed" Then
        Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, frmMain.hWnd, D3DCREATE_MIXED_VERTEXPROCESSING, D3DWindow)
    ElseIf Configs(1) = "Hardware" Then
        Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, frmMain.hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, D3DWindow)
    End If
    
    Set DS = Dx.DirectSoundCreate(DSEnum.GetGuid(2))
    DS.SetCooperativeLevel frmMain.hWnd, DSSCL_NORMAL
    DSBDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME
    
    D3DDevice.SetVertexShader Lit_FVF
    
    D3DDevice.SetRenderState D3DRS_LIGHTING, 0
    D3DDevice.SetRenderState D3DRS_AMBIENT, &H202020
    D3DDevice.SetRenderState D3DRS_CULLMODE, 1
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    D3DDevice.SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
    D3DDevice.SetTextureStageState 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR
    D3DDevice.SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DXMatrixPerspectiveFovLH matProj, pi / 4, 1, 0.1, 500
    D3DDevice.SetTransform D3DTS_PROJECTION, matProj
    
    '#################################MUSIC
    Call LoadMP3
    '#################################MUSIC
    
    frmMain.Show
    
    If InitialiseGeometry() = True Then
        Initialise = True
        Exit Function
    End If
    
ErrHandler:
    
    Debug.Print "Error Number Returned: " & Err.Number
    Initialise = False
End Function

Public Function LoadMP3() As Boolean
On Error GoTo BailOut:
        
    Set DSControl = New FilgraphManager
    
    Call DSControl.RenderFile(App.Path & "\sfx\jetclub1.mp3")

    Set DSAudio = DSControl
        
    DSAudio.Volume = 0
    DSAudio.Balance = 0
    
    Set DSEvent = DSControl
    Set DSPosition = DSControl
    If ObjPtr(DSPosition) Then DSPosition.Rate = 1#
    DSPosition.CurrentPosition = 0
    
    LoadMP3 = True
    Exit Function
BailOut:
    LoadMP3 = False
End Function
