Attribute VB_Name = "Gameplay"
Option Explicit

Public s_Raumschiff As PlayerType
Public s_Punkte As Long
Public s_Geld As Long
Public s_RaketenSlot(0 To 4) As Integer
Public s_ExtrasSlot(0 To 2) As Integer
Public s_Primary As PrimaryWeapon
Public s_Schwierigkeitsgrad As String
Public s_Continue As Integer
Public s_Level As String
Public s_Save As String
Public s_Highscore As String

Public WAY As String
Public WaveMove As Single

Public Type PrimaryWeapon
    Power As Single
    Frequency As Single
    Typ As Integer
End Type

Public Type PlayerType
    X As Single
    Y As Single
    Z As Single
    Drift As Single
    Shild As Integer
    Acceleration As Single
    Typ As Integer
    Armor As Single
    Reactor As Single
    Energy As Single
    UpdateSlots As Integer
    RocketSlots As Integer
    MaxTempo As Integer
    Tempo As Single
End Type

Public Sub LoadVariables()
    s_Raumschiff.Acceleration = 0.0005 ' testwerte
    s_Raumschiff.Armor = 5
    s_Raumschiff.Energy = 5
    s_Raumschiff.Reactor = 120
    s_Raumschiff.Typ = 1
    s_Raumschiff.RocketSlots = 8
    s_Raumschiff.UpdateSlots = 1
    s_Raumschiff.MaxTempo = 200

    s_Primary.Frequency = 0.5
    s_Primary.Power = 1
    s_Primary.Typ = 1

    s_Punkte = 0
    If s_Schwierigkeitsgrad = "massaker" Then s_Geld = 9500
    If s_Schwierigkeitsgrad = "leicht" Then s_Geld = 8000
    If s_Schwierigkeitsgrad = "mittel" Then s_Geld = 6500
    If s_Schwierigkeitsgrad = "schwer" Then s_Geld = 5000
    
    s_RaketenSlot(0) = 2
    s_RaketenSlot(1) = 2
    s_RaketenSlot(2) = 0
    s_RaketenSlot(3) = 0
    s_RaketenSlot(4) = 0
    
    If s_Schwierigkeitsgrad = "massaker" Then s_RaketenSlot(4) = 2
    If s_Schwierigkeitsgrad = "leicht" Then s_RaketenSlot(3) = 2
    'If s_Schwierigkeitsgrad = "mittel" Then nichts
    If s_Schwierigkeitsgrad = "schwer" Then s_RaketenSlot(1) = 0

    s_ExtrasSlot(0) = 0 'Leer.
    s_ExtrasSlot(1) = -1 'keinen Platz fr Extras.
    s_ExtrasSlot(2) = -1 'keinen Platz fr Extras, ab 1 geht's los.
    
    s_Level = "Level1"
End Sub

Public Sub Prepare_level1()
    Dim i As Integer

    EscRun = 0
    Gedrckt(13) = 0
    D3DDevice.LightEnable 0, 1
    D3DDevice.LightEnable 1, 0
    SetLevel(0) = 0
    SetLevel(1) = 132
    For i = 0 To 10
        Explosion(i).Gone = 100
    Next i
    
    PlayerX = 0
    RaketenNachladen = 15
    Player.X = 34
    Player.Y = 10
    Player.Z = 127
    Player.Typ = s_Raumschiff.Typ
    Player.Acceleration = 0
    Player.Energy = s_Raumschiff.Energy
    Player.Reactor = s_Raumschiff.Reactor
    Player.MaxTempo = s_Raumschiff.MaxTempo
    Player.Armor = s_Raumschiff.Armor
    Player.Tempo = 200
    Primary.Frequency = s_Primary.Frequency
    Primary.Power = s_Primary.Power
    Primary.Typ = s_Primary.Typ
    
    Call CheckExtras
    
    For i = 0 To 50
        Gegner(i).Y = 10
        Gegner(i).Typ = 0
    Next i
    
    Gimmick(0).X = 29
    Gimmick(0).Z = 0
    Gimmick(0).Typ = 29
    Gimmick(0).Rotation = Int(Rnd * 360)
    
    Gimmick(1).X = 24
    Gimmick(1).Z = -25
    Gimmick(1).Typ = 29
    Gimmick(1).Rotation = Int(Rnd * 360)
    
    Gimmick(2).X = 40
    Gimmick(2).Z = -50
    Gimmick(2).Typ = 29
    Gimmick(2).Rotation = Int(Rnd * 360)
    
    Gimmick(3).X = 35
    Gimmick(3).Z = -75
    Gimmick(3).Typ = 29
    Gimmick(3).Rotation = Int(Rnd * 360)
    
    Gimmick(4).X = 45
    Gimmick(4).Z = -100
    Gimmick(4).Typ = 29
    Gimmick(4).Rotation = Int(Rnd * 360)
    
    Gimmick(5).X = 26
    Gimmick(5).Z = -125
    Gimmick(5).Typ = 29
    Gimmick(5).Rotation = Int(Rnd * 360)
    
    Gimmick(6).X = 20
    Gimmick(6).Y = 4
    Gimmick(6).Z = -25
    Gimmick(6).Typ = 33
    Gimmick(6).Rotation = Int(Rnd * 360)
    
    Gimmick(7).X = 48
    Gimmick(7).Y = 4
    Gimmick(7).Z = -50
    Gimmick(7).Typ = 33
    Gimmick(7).Rotation = Int(Rnd * 360)
    
    Gimmick(8).X = 50
    Gimmick(8).Y = 4
    Gimmick(8).Z = -80
    Gimmick(8).Typ = 33
    Gimmick(8).Rotation = Int(Rnd * 360)
    
    Gimmick(9).X = 18
    Gimmick(9).Y = 4
    Gimmick(9).Z = -100
    Gimmick(9).Typ = 33
    Gimmick(9).Rotation = Int(Rnd * 360)
    
    Gimmick(10).Typ = 0
   
    '------------------------------------------------------------------------
    Gegner(0).X = 32
    Gegner(0).Z = 0
    Gegner(0).Typ = 16
    Gegner(0).Armor = 1
    
    Gegner(1).X = 38
    Gegner(1).Z = -10                                   '1
    Gegner(1).Typ = 16
    Gegner(1).Armor = 1
    
    Gegner(2).X = 34
    Gegner(2).Z = -20
    Gegner(2).Typ = 16
    Gegner(2).Armor = 1
    '------------------------------------------------------------------------
    Gegner(3).X = 34
    Gegner(3).Z = -110
    Gegner(3).Typ = 16
    Gegner(3).Armor = 1
    
    Gegner(4).X = 32
    Gegner(4).Z = -120                                   '2
    Gegner(4).Typ = 16
    Gegner(4).Armor = 1
    
    Gegner(5).X = 30
    Gegner(5).Z = -130
    Gegner(5).Typ = 16
    Gegner(5).Armor = 1
    '------------------------------------------------------------------------
    Gegner(6).X = 34
    Gegner(6).Z = -190
    Gegner(6).Typ = 16
    Gegner(6).Armor = 1
    
    Gegner(7).X = 36
    Gegner(7).Z = -200                                   '3
    Gegner(7).Typ = 16
    Gegner(7).Armor = 1
    
    Gegner(8).X = 38
    Gegner(8).Z = -210
    Gegner(8).Typ = 16
    Gegner(8).Armor = 1
    '------------------------------------------------------------------------
    Gegner(9).X = 42
    Gegner(9).Z = -260
    Gegner(9).Typ = 16
    Gegner(9).Armor = 1
    
    Gegner(10).X = 40
    Gegner(10).Z = -270                                 '4
    Gegner(10).Typ = 16
    Gegner(10).Armor = 1
    
    Gegner(11).X = 38
    Gegner(11).Z = -280
    Gegner(11).Typ = 16
    Gegner(11).Armor = 1
    '------------------------------------------------------------------------
    Gegner(12).X = 44
    Gegner(12).Z = -330
    Gegner(12).Typ = 16
    Gegner(12).Armor = 1
    Gegner(12).Richtung = 0
    
    Gegner(13).X = 42
    Gegner(13).Z = -340
    Gegner(13).Typ = 16
    Gegner(13).Armor = 1                                '5
    Gegner(13).Richtung = 0
    
    Gegner(14).X = 40
    Gegner(14).Z = -350
    Gegner(14).Typ = 16
    Gegner(14).Armor = 1
    Gegner(14).Richtung = 0
    
    Gegner(15).X = 28
    Gegner(15).Z = -355
    Gegner(15).Typ = 16
    Gegner(15).Armor = 1
    Gegner(15).Richtung = 1
    
    Gegner(16).X = 26
    Gegner(16).Z = -345
    Gegner(16).Typ = 16
    Gegner(16).Armor = 1
    Gegner(16).Richtung = 1
    
    Gegner(17).X = 24
    Gegner(17).Z = -335
    Gegner(17).Typ = 16
    Gegner(17).Armor = 1
    Gegner(17).Richtung = 1
    
    '------------------------------------------------------------------------
    Gegner(18).X = 46
    Gegner(18).Z = -420
    Gegner(18).Typ = 22
    Gegner(18).Armor = 2
    
    Gegner(19).X = 42
    Gegner(19).Z = -420
    Gegner(19).Typ = 22
    Gegner(19).Armor = 2
    
    Gegner(20).X = 38
    Gegner(20).Z = -410
    Gegner(20).Typ = 22
    Gegner(20).Armor = 2                                '6
    
    Gegner(21).X = 34
    Gegner(21).Z = -410
    Gegner(21).Typ = 22
    Gegner(21).Armor = 2
    
    Gegner(22).X = 30
    Gegner(22).Z = -410
    Gegner(22).Typ = 22
    Gegner(22).Armor = 2
    
    Gegner(23).X = 26
    Gegner(23).Z = -420
    Gegner(23).Typ = 22
    Gegner(23).Armor = 2
    
    Gegner(24).X = 22
    Gegner(24).Z = -420
    Gegner(24).Typ = 22
    Gegner(24).Armor = 2
    '------------------------------------------------------------------------
    Gegner(25).X = 40
    Gegner(25).Z = -485
    Gegner(25).Typ = 22
    Gegner(25).Armor = 2
    Gegner(25).Richtung = 0
    
    Gegner(26).X = 38
    Gegner(26).Z = -495
    Gegner(26).Typ = 22
    Gegner(26).Armor = 2
    Gegner(26).Richtung = 0
    
    Gegner(27).X = 36
    Gegner(27).Z = -505
    Gegner(27).Typ = 22
    Gegner(27).Armor = 2
    Gegner(27).Richtung = 0                             '7
    
    Gegner(28).X = 34
    Gegner(28).Z = -520
    Gegner(28).Typ = 22
    Gegner(28).Armor = 2
    
    Gegner(29).X = 32
    Gegner(29).Z = -510
    Gegner(29).Typ = 22
    Gegner(29).Armor = 2
    Gegner(29).Richtung = 1
    
    Gegner(30).X = 30
    Gegner(30).Z = -500
    Gegner(30).Typ = 22
    Gegner(30).Armor = 2
    Gegner(30).Richtung = 1
    
    Gegner(31).X = 28
    Gegner(31).Z = -490
    Gegner(31).Typ = 22
    Gegner(31).Armor = 2
    Gegner(31).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(32).X = 40
    Gegner(32).Z = -600
    Gegner(32).Typ = 38
    Gegner(32).Armor = 3
    Gegner(32).Richtung = 0
    
    Gegner(33).X = 38
    Gegner(33).Z = -590
    Gegner(33).Typ = 38
    Gegner(33).Armor = 3
    Gegner(33).Richtung = 0
    
    Gegner(34).X = 36
    Gegner(34).Z = -580
    Gegner(34).Typ = 38
    Gegner(34).Armor = 3
    Gegner(34).Richtung = 0                            '8
    
    Gegner(35).X = 34
    Gegner(35).Z = -570
    Gegner(35).Typ = 38
    Gegner(35).Armor = 3
    
    Gegner(36).X = 32
    Gegner(36).Z = -585
    Gegner(36).Typ = 38
    Gegner(36).Armor = 3
    Gegner(36).Richtung = 1
    
    Gegner(37).X = 30
    Gegner(37).Z = -595
    Gegner(37).Typ = 38
    Gegner(37).Armor = 3
    Gegner(37).Richtung = 1
    
    Gegner(38).X = 28
    Gegner(38).Z = -605
    Gegner(38).Typ = 38
    Gegner(38).Armor = 3
    Gegner(38).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(39).X = 34
    Gegner(39).Z = -650
    Gegner(39).Typ = 38
    Gegner(39).Armor = 3
    
    Gegner(40).X = 34
    Gegner(40).Z = -660
    Gegner(40).Typ = 38
    Gegner(40).Armor = 3
    
    Gegner(41).X = 36
    Gegner(41).Z = -670
    Gegner(41).Typ = 38
    Gegner(41).Armor = 3                                '9
    
    Gegner(42).X = 38
    Gegner(42).Z = -680
    Gegner(42).Typ = 38
    Gegner(42).Armor = 3
    '------------------------------------------------------------------------
    Gegner(43).X = 34
    Gegner(43).Z = -720
    Gegner(43).Typ = 38
    Gegner(43).Armor = 3
    
    Gegner(44).X = 34
    Gegner(44).Z = -730
    Gegner(44).Typ = 38
    Gegner(44).Armor = 3
    
    Gegner(45).X = 32
    Gegner(45).Z = -740
    Gegner(45).Typ = 38
    Gegner(45).Armor = 3                                '10
    
    Gegner(46).X = 30
    Gegner(46).Z = -750
    Gegner(46).Typ = 38
    Gegner(46).Armor = 3
    
    For i = 0 To 46
        If s_Schwierigkeitsgrad = "schwer" Then
            Gegner(i).Armor = Gegner(i).Armor * 1.5
        ElseIf s_Schwierigkeitsgrad = "mittel" Then
            Gegner(i).Armor = Gegner(i).Armor * 1
        ElseIf s_Schwierigkeitsgrad = "leicht" Then
            Gegner(i).Armor = Gegner(i).Armor * 0.5
        ElseIf s_Schwierigkeitsgrad = "massaker" Then
            Gegner(i).Armor = 1
        End If
        Gegner(i).Typsave = Gegner(i).Typ
        Gegner(i).Armorsave = Gegner(i).Armor
    Next i
End Sub

Public Sub Prepare_level2()
    Dim i As Integer

    EscRun = 0
    Gedrckt(13) = 0
    D3DDevice.LightEnable 0, 1
    D3DDevice.LightEnable 1, 0
    SetLevel(0) = 0
    SetLevel(1) = 132
    For i = 0 To 10
        Explosion(i).Gone = 100
    Next i
    
    PlayerX = 0
    RaketenNachladen = 15
    Player.X = 34
    Player.Y = 10
    Player.Z = 127
    Player.Typ = s_Raumschiff.Typ
    Player.Acceleration = 0
    Player.Energy = s_Raumschiff.Energy
    Player.Reactor = s_Raumschiff.Reactor
    Player.MaxTempo = s_Raumschiff.MaxTempo
    Player.Armor = s_Raumschiff.Armor
    Player.Tempo = 200
    Primary.Frequency = s_Primary.Frequency
    Primary.Power = s_Primary.Power
    Primary.Typ = s_Primary.Typ
    
    Call CheckExtras
    
    For i = 0 To 50
        Gegner(i).Y = 10
        Gegner(i).Typ = 0
    Next i
    
    Gimmick(0).X = 29
    Gimmick(0).Y = 5
    Gimmick(0).Z = 0
    Gimmick(0).Typ = 27
    Gimmick(0).Rotation = Int(Rnd * 360)
    
    Gimmick(1).X = 24
    Gimmick(1).Z = -25
    Gimmick(1).Typ = 28
    Gimmick(1).Rotation = Int(Rnd * 360)
    
    Gimmick(2).X = 40
    Gimmick(2).Z = -50
    Gimmick(2).Typ = 27
    Gimmick(2).Rotation = Int(Rnd * 360)
    
    Gimmick(3).X = 35
    Gimmick(3).Z = -75
    Gimmick(3).Typ = 28
    Gimmick(3).Rotation = Int(Rnd * 360)
    
    Gimmick(4).X = 45
    Gimmick(4).Z = -100
    Gimmick(4).Typ = 27
    Gimmick(4).Rotation = Int(Rnd * 360)
    
    Gimmick(5).X = 26
    Gimmick(5).Z = -125
    Gimmick(5).Typ = 27
    Gimmick(5).Rotation = Int(Rnd * 360)
    
    Gimmick(6).X = 34
    Gimmick(6).Z = -150
    Gimmick(6).Typ = 28
    Gimmick(6).Rotation = Int(Rnd * 360)
    
    Gimmick(7).X = 48
    Gimmick(7).Y = 4
    Gimmick(7).Z = -50
    Gimmick(7).Typ = 0
    Gimmick(7).Rotation = Int(Rnd * 360)
    
    Gimmick(8).X = 50
    Gimmick(8).Y = 4
    Gimmick(8).Z = -80
    Gimmick(8).Typ = 0
    Gimmick(8).Rotation = Int(Rnd * 360)
    
    Gimmick(9).X = 18
    Gimmick(9).Y = 4
    Gimmick(6).Z = -100
    Gimmick(9).Typ = 0
    Gimmick(9).Rotation = Int(Rnd * 360)
    
    Gimmick(10).X = 42
    Gimmick(10).Y = 4
    Gimmick(10).Z = -100
    Gimmick(10).Typ = 0
    Gimmick(10).Rotation = Int(Rnd * 360)
    '------------------------------------------------------------------------
    Gegner(0).X = 30
    Gegner(0).Z = 0
    Gegner(0).Typ = 19
    Gegner(0).Armor = 3
    
    Gegner(1).X = 38
    Gegner(1).Z = 0                                   '1
    Gegner(1).Typ = 19
    Gegner(1).Armor = 3
    
    Gegner(2).X = 34
    Gegner(2).Z = -10
    Gegner(2).Typ = 19
    Gegner(2).Armor = 3
    '------------------------------------------------------------------------
    Gegner(3).X = 40
    Gegner(3).Z = -70
    Gegner(3).Typ = 19
    Gegner(3).Armor = 3
    
    Gegner(4).X = 37
    Gegner(4).Z = -80
    Gegner(4).Typ = 19
    Gegner(4).Armor = 3
    
    Gegner(5).X = 34
    Gegner(5).Z = -90
    Gegner(5).Typ = 19
    Gegner(5).Armor = 3

    Gegner(6).X = 31
    Gegner(6).Z = -80                                        '2
    Gegner(6).Typ = 19
    Gegner(6).Armor = 3
    
    Gegner(7).X = 28
    Gegner(7).Z = -70
    Gegner(7).Typ = 19
    Gegner(7).Armor = 3
    
    Gegner(8).X = 34
    Gegner(8).Z = -100
    Gegner(8).Typ = 19
    Gegner(8).Armor = 3
    '------------------------------------------------------------------------
    Gegner(9).X = 36
    Gegner(9).Z = -155
    Gegner(9).Typ = 19
    Gegner(9).Armor = 3
    Gegner(9).Richtung = 1
    
    Gegner(10).X = 32
    Gegner(10).Z = -160
    Gegner(10).Typ = 19
    Gegner(10).Armor = 3
    Gegner(10).Richtung = 0
    
    Gegner(11).X = 30
    Gegner(11).Z = -190
    Gegner(11).Typ = 19
    Gegner(11).Armor = 3
    Gegner(11).Richtung = 0
    
    Gegner(12).X = 36
    Gegner(12).Z = -175                                       '3
    Gegner(12).Typ = 19
    Gegner(12).Armor = 3
    Gegner(12).Richtung = 1
    
    Gegner(13).X = 32
    Gegner(13).Z = -180
    Gegner(13).Typ = 19
    Gegner(13).Armor = 3
    Gegner(13).Richtung = 0
    
    Gegner(14).X = 38
    Gegner(14).Z = -185
    Gegner(14).Typ = 25
    Gegner(14).Armor = 4
    Gegner(14).Richtung = 1
    
    Gegner(15).X = 34
    Gegner(15).Z = -170
    Gegner(15).Typ = 25
    Gegner(15).Armor = 4
    '------------------------------------------------------------------------
    Gegner(16).X = 34
    Gegner(16).Z = -230
    Gegner(16).Typ = 25
    Gegner(16).Armor = 4
                                                    '4
    Gegner(17).X = 36
    Gegner(17).Z = -220
    Gegner(17).Typ = 25
    Gegner(17).Armor = 4
    
    Gegner(18).X = 32
    Gegner(18).Z = -220
    Gegner(18).Typ = 25
    Gegner(18).Armor = 4
    '------------------------------------------------------------------------
    Gegner(19).X = 38
    Gegner(19).Z = -330
    Gegner(19).Typ = 25
    Gegner(19).Armor = 4
    Gegner(19).Richtung = 1
    
    Gegner(20).X = 36
    Gegner(20).Z = -320
    Gegner(20).Typ = 25
    Gegner(20).Armor = 4                                '5
    Gegner(20).Richtung = 1
    
    Gegner(21).X = 34
    Gegner(21).Z = -315
    Gegner(21).Typ = 25
    Gegner(21).Armor = 4
    
    Gegner(22).X = 32
    Gegner(22).Z = -325
    Gegner(22).Typ = 25
    Gegner(22).Armor = 4
    Gegner(22).Richtung = 0
    
    Gegner(23).X = 30
    Gegner(23).Z = -335
    Gegner(23).Typ = 25
    Gegner(23).Armor = 4
    Gegner(23).Richtung = 0
    '------------------------------------------------------------------------
    Gegner(24).X = 34
    Gegner(24).Z = -400
    Gegner(24).Typ = 25
    Gegner(24).Armor = 4
    
    Gegner(25).X = 36
    Gegner(25).Z = -410
    Gegner(25).Typ = 25
    Gegner(25).Armor = 4
    Gegner(25).Richtung = 0
    
    Gegner(26).X = 32
    Gegner(26).Z = -410
    Gegner(26).Typ = 25
    Gegner(26).Armor = 4
    Gegner(26).Richtung = 0
    
    Gegner(27).X = 38
    Gegner(27).Z = -420
    Gegner(27).Typ = 26
    Gegner(27).Armor = 5
    Gegner(27).Richtung = 0                             '6
    
    Gegner(28).X = 34
    Gegner(28).Z = -430
    Gegner(28).Typ = 26
    Gegner(28).Armor = 5
    
    Gegner(29).X = 30
    Gegner(29).Z = -420
    Gegner(29).Typ = 26
    Gegner(29).Armor = 5
    Gegner(29).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(30).X = 40
    Gegner(30).Z = -485
    Gegner(30).Typ = 26
    Gegner(30).Armor = 5
    Gegner(30).Richtung = 1
    
    Gegner(31).X = 38
    Gegner(31).Z = -495
    Gegner(31).Typ = 26
    Gegner(31).Armor = 5
    Gegner(31).Richtung = 1

    Gegner(32).X = 36
    Gegner(32).Z = -505
    Gegner(32).Typ = 26
    Gegner(32).Armor = 5                                '7
    Gegner(32).Richtung = 1
    
    Gegner(33).X = 32
    Gegner(33).Z = -500
    Gegner(33).Typ = 26
    Gegner(33).Armor = 5
    Gegner(33).Richtung = 0
    
    Gegner(34).X = 30
    Gegner(34).Z = -490
    Gegner(34).Typ = 26
    Gegner(34).Armor = 5
    Gegner(34).Richtung = 0
    
    Gegner(35).X = 28
    Gegner(35).Z = -480
    Gegner(35).Typ = 26
    Gegner(35).Armor = 5
    Gegner(35).Richtung = 0
    '------------------------------------------------------------------------
    Gegner(36).X = 36
    Gegner(36).Z = -560
    Gegner(36).Typ = 26
    Gegner(36).Armor = 5
    Gegner(36).Richtung = 1
    
    Gegner(37).X = 34
    Gegner(37).Z = -570
    Gegner(37).Typ = 26
    Gegner(37).Armor = 5
    Gegner(37).Richtung = 1
    
    Gegner(38).X = 32
    Gegner(38).Z = -560
    Gegner(38).Typ = 26
    Gegner(38).Armor = 5                            '8
    Gegner(38).Richtung = 1
    
    Gegner(39).X = 38
    Gegner(39).Z = -600
    Gegner(39).Typ = 26
    Gegner(39).Armor = 5
    
    Gegner(40).X = 34
    Gegner(40).Z = -620
    Gegner(40).Typ = 26
    Gegner(40).Armor = 5
    
    Gegner(41).X = 30
    Gegner(41).Z = -600
    Gegner(41).Typ = 26
    Gegner(41).Armor = 5
    '------------------------------------------------------------------------
    
    For i = 0 To 41
        If s_Schwierigkeitsgrad = "schwer" Then
            Gegner(i).Armor = Gegner(i).Armor * 1.5
        ElseIf s_Schwierigkeitsgrad = "mittel" Then
            Gegner(i).Armor = Gegner(i).Armor * 1
        ElseIf s_Schwierigkeitsgrad = "leicht" Then
            Gegner(i).Armor = Gegner(i).Armor * 0.5
        ElseIf s_Schwierigkeitsgrad = "massaker" Then
            Gegner(i).Armor = 1
        End If
        Gegner(i).Typsave = Gegner(i).Typ
        Gegner(i).Armorsave = Gegner(i).Armor
    Next i
End Sub

Public Sub Prepare_level3()
    Dim i As Integer

    EscRun = 0
    Gedrckt(13) = 0
    D3DDevice.LightEnable 0, 1
    D3DDevice.LightEnable 1, 0
    SetLevel(0) = 0
    SetLevel(1) = 132
    For i = 0 To 10
        Explosion(i).Gone = 100
    Next i
    
    PlayerX = 0
    RaketenNachladen = 15
    Player.X = 34
    Player.Y = 10
    Player.Z = 127
    Player.Typ = s_Raumschiff.Typ
    Player.Acceleration = 0
    Player.Energy = s_Raumschiff.Energy
    Player.Reactor = s_Raumschiff.Reactor
    Player.MaxTempo = s_Raumschiff.MaxTempo
    Player.Armor = s_Raumschiff.Armor
    Player.Tempo = 200
    Primary.Frequency = s_Primary.Frequency
    Primary.Power = s_Primary.Power
    Primary.Typ = s_Primary.Typ
    
    Call CheckExtras
    
    For i = 0 To 50
        Gegner(i).Y = 10
        Gegner(i).Typ = 0
    Next i
    
    Gimmick(0).X = 29
    Gimmick(0).Y = 5
    Gimmick(0).Z = 0
    Gimmick(0).Typ = 32
    Gimmick(0).Rotation = Int(Rnd * 360)
    
    Gimmick(1).X = 24
    Gimmick(1).Y = 5
    Gimmick(1).Z = -25
    Gimmick(1).Typ = 32
    Gimmick(1).Rotation = Int(Rnd * 360)
    
    Gimmick(2).X = 40
    Gimmick(2).Y = 5
    Gimmick(2).Z = -50
    Gimmick(2).Typ = 32
    Gimmick(2).Rotation = Int(Rnd * 360)
    
    Gimmick(3).X = 35
    Gimmick(3).Y = 5
    Gimmick(3).Z = -75
    Gimmick(3).Typ = 32
    Gimmick(3).Rotation = Int(Rnd * 360)
    
    Gimmick(4).X = 45
    Gimmick(4).Y = 5
    Gimmick(4).Z = -100
    Gimmick(4).Typ = 32
    Gimmick(4).Rotation = Int(Rnd * 360)
    
    Gimmick(5).X = 26
    Gimmick(5).Y = 5
    Gimmick(5).Z = -125
    Gimmick(5).Typ = 32
    Gimmick(5).Rotation = Int(Rnd * 360)
    
    Gimmick(6).X = 42
    Gimmick(6).Y = 4
    Gimmick(6).Z = -5
    Gimmick(6).Typ = 35
    Gimmick(6).Rotation = Int(Rnd * 360)
    
    Gimmick(7).X = 29
    Gimmick(7).Y = 4
    Gimmick(7).Z = -25
    Gimmick(7).Typ = 35
    Gimmick(7).Rotation = Int(Rnd * 360)
    
    Gimmick(8).X = 35
    Gimmick(8).Y = 4
    Gimmick(8).Z = -45
    Gimmick(8).Typ = 35
    Gimmick(8).Rotation = Int(Rnd * 360)
    
    Gimmick(9).X = 26
    Gimmick(9).Y = 4
    Gimmick(9).Z = -80
    Gimmick(9).Typ = 35
    Gimmick(9).Rotation = Int(Rnd * 360)
    
    Gimmick(10).X = 42
    Gimmick(10).Y = 4
    Gimmick(10).Z = -100
    Gimmick(10).Typ = 35
    Gimmick(10).Rotation = Int(Rnd * 360)
    
    '------------------------------------------------------------------------
    Gegner(0).X = 36
    Gegner(0).Z = 0
    Gegner(0).Typ = 18
    Gegner(0).Armor = 5
    
    Gegner(1).X = 38
    Gegner(1).Z = -10                                   '1
    Gegner(1).Typ = 18
    Gegner(1).Armor = 5
    
    Gegner(2).X = 34
    Gegner(2).Z = -20
    Gegner(2).Typ = 18
    Gegner(2).Armor = 5
    '------------------------------------------------------------------------
    Gegner(3).X = 34
    Gegner(3).Z = -110
    Gegner(3).Typ = 18
    Gegner(3).Armor = 5
    
    Gegner(4).X = 32
    Gegner(4).Z = -120                                   '2
    Gegner(4).Typ = 18
    Gegner(4).Armor = 5
    
    Gegner(5).X = 30
    Gegner(5).Z = -110
    Gegner(5).Typ = 18
    Gegner(5).Armor = 5
    '------------------------------------------------------------------------
    Gegner(6).X = 34
    Gegner(6).Z = -190
    Gegner(6).Typ = 18
    Gegner(6).Armor = 5
    
    Gegner(7).X = 36
    Gegner(7).Z = -200                                   '3
    Gegner(7).Typ = 18
    Gegner(7).Armor = 5
    
    Gegner(8).X = 38
    Gegner(8).Z = -210
    Gegner(8).Typ = 18
    Gegner(8).Armor = 5
    '------------------------------------------------------------------------
    Gegner(9).X = 42
    Gegner(9).Z = -260
    Gegner(9).Typ = 18
    Gegner(9).Armor = 5
    
    Gegner(10).X = 40
    Gegner(10).Z = -270                                 '4
    Gegner(10).Typ = 18
    Gegner(10).Armor = 5
    
    Gegner(11).X = 38
    Gegner(11).Z = -280
    Gegner(11).Typ = 18
    Gegner(11).Armor = 5
    '------------------------------------------------------------------------
    Gegner(12).X = 40
    Gegner(12).Z = -330
    Gegner(12).Typ = 18
    Gegner(12).Armor = 5
    Gegner(12).Richtung = 0
    
    Gegner(13).X = 42
    Gegner(13).Z = -340
    Gegner(13).Typ = 18
    Gegner(13).Armor = 5                                '5
    Gegner(13).Richtung = 0
    
    Gegner(14).X = 44
    Gegner(14).Z = -350
    Gegner(14).Typ = 18
    Gegner(14).Armor = 5
    Gegner(14).Richtung = 0
    
    Gegner(15).X = 24
    Gegner(15).Z = -355
    Gegner(15).Typ = 18
    Gegner(15).Armor = 5
    Gegner(15).Richtung = 1
    
    Gegner(16).X = 26
    Gegner(16).Z = -345
    Gegner(16).Typ = 20
    Gegner(16).Armor = 6
    Gegner(16).Richtung = 1
    
    Gegner(17).X = 28
    Gegner(17).Z = -335
    Gegner(17).Typ = 20
    Gegner(17).Armor = 6
    Gegner(17).Richtung = 1
    
    '------------------------------------------------------------------------
    Gegner(18).X = 46
    Gegner(18).Z = -420
    Gegner(18).Typ = 20
    Gegner(18).Armor = 6
    
    Gegner(19).X = 42
    Gegner(19).Z = -420
    Gegner(19).Typ = 20
    Gegner(19).Armor = 6
    
    Gegner(20).X = 38
    Gegner(20).Z = -410
    Gegner(20).Typ = 20
    Gegner(20).Armor = 6                                '6
    
    Gegner(21).X = 34
    Gegner(21).Z = -410
    Gegner(21).Typ = 20
    Gegner(21).Armor = 6
    
    Gegner(22).X = 30
    Gegner(22).Z = -410
    Gegner(22).Typ = 20
    Gegner(22).Armor = 6
    
    Gegner(23).X = 26
    Gegner(23).Z = -420
    Gegner(23).Typ = 20
    Gegner(23).Armor = 6
    
    Gegner(24).X = 22
    Gegner(24).Z = -420
    Gegner(24).Typ = 20
    Gegner(24).Armor = 6
    '------------------------------------------------------------------------
    Gegner(25).X = 40
    Gegner(25).Z = -500
    Gegner(25).Typ = 20
    Gegner(25).Armor = 6
    Gegner(25).Richtung = 0
    
    Gegner(26).X = 38
    Gegner(26).Z = -510
    Gegner(26).Typ = 20
    Gegner(26).Armor = 6
    Gegner(26).Richtung = 0
    
    Gegner(27).X = 36
    Gegner(27).Z = -520
    Gegner(27).Typ = 20
    Gegner(27).Armor = 6
    Gegner(27).Richtung = 0                             '7
    
    Gegner(28).X = 34
    Gegner(28).Z = -525
    Gegner(28).Typ = 20
    Gegner(28).Armor = 6
    
    Gegner(29).X = 32
    Gegner(29).Z = -515
    Gegner(29).Typ = 20
    Gegner(29).Armor = 6
    Gegner(29).Richtung = 1
    
    Gegner(30).X = 30
    Gegner(30).Z = -505
    Gegner(30).Typ = 20
    Gegner(30).Armor = 6
    Gegner(30).Richtung = 1
    
    Gegner(31).X = 28
    Gegner(31).Z = -495
    Gegner(31).Typ = 20
    Gegner(31).Armor = 6
    Gegner(31).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(32).X = 40
    Gegner(32).Z = -600
    Gegner(32).Typ = 24
    Gegner(32).Armor = 7
    Gegner(32).Richtung = 0
    
    Gegner(33).X = 38
    Gegner(33).Z = -590
    Gegner(33).Typ = 24
    Gegner(33).Armor = 7
    Gegner(33).Richtung = 0
    
    Gegner(34).X = 36
    Gegner(34).Z = -580
    Gegner(34).Typ = 24
    Gegner(34).Armor = 7
    Gegner(34).Richtung = 0                            '8
    
    Gegner(35).X = 34
    Gegner(35).Z = -575
    Gegner(35).Typ = 24
    Gegner(35).Armor = 7
    
    Gegner(36).X = 32
    Gegner(36).Z = -585
    Gegner(36).Typ = 24
    Gegner(36).Armor = 7
    Gegner(36).Richtung = 1
    
    Gegner(37).X = 30
    Gegner(37).Z = -595
    Gegner(37).Typ = 24
    Gegner(37).Armor = 7
    Gegner(37).Richtung = 1
    
    Gegner(38).X = 28
    Gegner(38).Z = -605
    Gegner(38).Typ = 24
    Gegner(38).Armor = 7
    Gegner(38).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(39).X = 34
    Gegner(39).Z = -660
    Gegner(39).Typ = 24
    Gegner(39).Armor = 7
    Gegner(39).Richtung = 1
    
    Gegner(40).X = 32
    Gegner(40).Z = -650
    Gegner(40).Typ = 24
    Gegner(40).Armor = 7
    Gegner(40).Richtung = 1
    
    Gegner(41).X = 36
    Gegner(41).Z = -670
    Gegner(41).Typ = 24
    Gegner(41).Armor = 7
    Gegner(41).Richtung = 1                     '9
    
    Gegner(42).X = 38
    Gegner(42).Z = -680
    Gegner(42).Typ = 24
    Gegner(42).Armor = 7
    Gegner(42).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(43).X = 36
    Gegner(43).Z = -720
    Gegner(43).Typ = 24
    Gegner(43).Armor = 7
    Gegner(43).Richtung = 1
    
    Gegner(44).X = 34
    Gegner(44).Z = -730
    Gegner(44).Typ = 24
    Gegner(44).Armor = 7
    Gegner(44).Richtung = 1
    
    Gegner(45).X = 32
    Gegner(45).Z = -740                                 '10
    Gegner(45).Typ = 24
    Gegner(45).Armor = 7
    Gegner(45).Richtung = 1
    
    Gegner(46).X = 30
    Gegner(46).Z = -750
    Gegner(46).Typ = 24
    Gegner(46).Armor = 7
    Gegner(46).Richtung = 1
    
    For i = 0 To 46
        If s_Schwierigkeitsgrad = "schwer" Then
            Gegner(i).Armor = Gegner(i).Armor * 1.5
        ElseIf s_Schwierigkeitsgrad = "mittel" Then
            Gegner(i).Armor = Gegner(i).Armor * 1
        ElseIf s_Schwierigkeitsgrad = "leicht" Then
            Gegner(i).Armor = Gegner(i).Armor * 0.5
        ElseIf s_Schwierigkeitsgrad = "massaker" Then
            Gegner(i).Armor = 1
        End If
        Gegner(i).Typsave = Gegner(i).Typ
        Gegner(i).Armorsave = Gegner(i).Armor
    Next i
End Sub

Public Sub Prepare_level4()
    Dim i As Integer

    EscRun = 0
    Gedrckt(13) = 0
    D3DDevice.LightEnable 0, 1
    D3DDevice.LightEnable 1, 0
    SetLevel(0) = 0
    SetLevel(1) = 132
    For i = 0 To 10
        Explosion(i).Gone = 100
    Next i
    
    PlayerX = 0
    RaketenNachladen = 15
    Player.X = 34
    Player.Y = 10
    Player.Z = 127
    Player.Typ = s_Raumschiff.Typ
    Player.Acceleration = 0
    Player.Energy = s_Raumschiff.Energy
    Player.Reactor = s_Raumschiff.Reactor
    Player.MaxTempo = s_Raumschiff.MaxTempo
    Player.Armor = s_Raumschiff.Armor
    Player.Tempo = 200
    Primary.Frequency = s_Primary.Frequency
    Primary.Power = s_Primary.Power
    Primary.Typ = s_Primary.Typ
    
    Call CheckExtras
    
    For i = 0 To 50
        Gegner(i).Y = 10
        Gegner(i).Typ = 0
    Next i
    
        '30 31 34
    Gimmick(0).X = 29
    Gimmick(0).Y = 3
    Gimmick(0).Z = 0
    Gimmick(0).Typ = 30
    Gimmick(0).Rotation = Int(Rnd * 360)
    
    Gimmick(1).X = 24
    Gimmick(1).Y = 3
    Gimmick(1).Z = -25
    Gimmick(1).Typ = 31
    Gimmick(1).Rotation = Int(Rnd * 360)
    
    Gimmick(2).X = 40
    Gimmick(2).Y = 3
    Gimmick(2).Z = -50
    Gimmick(2).Typ = 34
    Gimmick(2).Rotation = Int(Rnd * 360)
    
    Gimmick(3).X = 35
    Gimmick(3).Y = 3
    Gimmick(3).Z = -75
    Gimmick(3).Typ = 30
    Gimmick(3).Rotation = Int(Rnd * 360)
    
    Gimmick(4).X = 45
    Gimmick(4).Y = 3
    Gimmick(4).Z = -100
    Gimmick(4).Typ = 31
    Gimmick(4).Rotation = Int(Rnd * 360)
    
    Gimmick(5).X = 26
    Gimmick(5).Y = 3
    Gimmick(5).Z = -125
    Gimmick(5).Typ = 34
    Gimmick(5).Rotation = Int(Rnd * 360)
    
    Gimmick(6).X = 42
    Gimmick(6).Y = 3
    Gimmick(6).Z = -5
    Gimmick(6).Typ = 30
    Gimmick(6).Rotation = Int(Rnd * 360)
    
    Gimmick(7).X = 29
    Gimmick(7).Y = 3
    Gimmick(7).Z = -25
    Gimmick(7).Typ = 31
    Gimmick(7).Rotation = Int(Rnd * 360)
    
    Gimmick(8).X = 35
    Gimmick(8).Y = 3
    Gimmick(8).Z = -45
    Gimmick(8).Typ = 34
    Gimmick(8).Rotation = Int(Rnd * 360)
    
    Gimmick(9).X = 26
    Gimmick(9).Y = 3
    Gimmick(9).Z = -80
    Gimmick(9).Typ = 30
    Gimmick(9).Rotation = Int(Rnd * 360)
    
    Gimmick(10).X = 42
    Gimmick(10).Y = 3
    Gimmick(10).Z = -100
    Gimmick(10).Typ = 31
    Gimmick(10).Rotation = Int(Rnd * 360)
    
    '------------------------------------------------------------------------
    Gegner(0).X = 30
    Gegner(0).Z = 0
    Gegner(0).Typ = 14
    Gegner(0).Armor = 7
    
    Gegner(1).X = 38
    Gegner(1).Z = 0                                   '1
    Gegner(1).Typ = 14
    Gegner(1).Armor = 7
    
    Gegner(2).X = 34
    Gegner(2).Z = -10
    Gegner(2).Typ = 14
    Gegner(2).Armor = 7
    '------------------------------------------------------------------------
    Gegner(3).X = 40
    Gegner(3).Z = -70
    Gegner(3).Typ = 14
    Gegner(3).Armor = 7
    
    Gegner(4).X = 37
    Gegner(4).Z = -80
    Gegner(4).Typ = 14
    Gegner(4).Armor = 7
    
    Gegner(5).X = 32
    Gegner(5).Z = -90
    Gegner(5).Typ = 14
    Gegner(5).Armor = 7

    Gegner(6).X = 31
    Gegner(6).Z = -80                                        '2
    Gegner(6).Typ = 14
    Gegner(6).Armor = 7
    
    Gegner(7).X = 28
    Gegner(7).Z = -70
    Gegner(7).Typ = 14
    Gegner(7).Armor = 7
    
    Gegner(8).X = 32
    Gegner(8).Z = -90
    Gegner(8).Typ = 14
    Gegner(8).Armor = 7
    '------------------------------------------------------------------------
    Gegner(9).X = 36
    Gegner(9).Z = -155
    Gegner(9).Typ = 14
    Gegner(9).Armor = 7
    Gegner(9).Richtung = 1
    
    Gegner(10).X = 32
    Gegner(10).Z = -160
    Gegner(10).Typ = 14
    Gegner(10).Armor = 7
    Gegner(10).Richtung = 0
    
    Gegner(11).X = 30
    Gegner(11).Z = -150
    Gegner(11).Typ = 14
    Gegner(11).Armor = 7
    Gegner(11).Richtung = 0
    
    Gegner(12).X = 36
    Gegner(12).Z = -175                                       '3
    Gegner(12).Typ = 14
    Gegner(12).Armor = 7
    Gegner(12).Richtung = 1
    
    Gegner(13).X = 32
    Gegner(13).Z = -180
    Gegner(13).Typ = 14
    Gegner(13).Armor = 7
    Gegner(13).Richtung = 0
    
    Gegner(14).X = 38
    Gegner(14).Z = -145
    Gegner(14).Typ = 21
    Gegner(14).Armor = 8
    Gegner(14).Richtung = 1
    
    Gegner(15).X = 34
    Gegner(15).Z = -170
    Gegner(15).Typ = 21
    Gegner(15).Armor = 8
    '------------------------------------------------------------------------
    Gegner(16).X = 34
    Gegner(16).Z = -230
    Gegner(16).Typ = 21
    Gegner(16).Armor = 8
                                                    '4
    Gegner(17).X = 36
    Gegner(17).Z = -220
    Gegner(17).Typ = 21
    Gegner(17).Armor = 8
    
    Gegner(18).X = 32
    Gegner(18).Z = -220
    Gegner(18).Typ = 21
    Gegner(18).Armor = 8
    '------------------------------------------------------------------------
    Gegner(19).X = 38
    Gegner(19).Z = -330
    Gegner(19).Typ = 21
    Gegner(19).Armor = 8
    Gegner(19).Richtung = 1
    
    Gegner(20).X = 36
    Gegner(20).Z = -320
    Gegner(20).Typ = 21
    Gegner(20).Armor = 8                                '5
    Gegner(20).Richtung = 1
    
    Gegner(21).X = 34
    Gegner(21).Z = -315
    Gegner(21).Typ = 21
    Gegner(21).Armor = 8
    
    Gegner(22).X = 32
    Gegner(22).Z = -325
    Gegner(22).Typ = 21
    Gegner(22).Armor = 8
    Gegner(22).Richtung = 0
    
    Gegner(23).X = 30
    Gegner(23).Z = -335
    Gegner(23).Typ = 21
    Gegner(23).Armor = 8
    Gegner(23).Richtung = 0
    '------------------------------------------------------------------------
    Gegner(24).X = 44
    Gegner(24).Z = -410
    Gegner(24).Typ = 21
    Gegner(24).Armor = 8
    Gegner(24).Richtung = 0
    
    Gegner(25).X = 42
    Gegner(25).Z = -420
    Gegner(25).Typ = 21
    Gegner(25).Armor = 8                                '5
    Gegner(25).Richtung = 0
    
    Gegner(26).X = 40
    Gegner(26).Z = -430
    Gegner(26).Typ = 21
    Gegner(26).Armor = 8
    Gegner(26).Richtung = 0
    
    Gegner(27).X = 28
    Gegner(27).Z = -435
    Gegner(27).Typ = 21
    Gegner(27).Armor = 8
    Gegner(27).Richtung = 1
    
    Gegner(28).X = 26
    Gegner(28).Z = -425
    Gegner(28).Typ = 21
    Gegner(28).Armor = 8
    Gegner(28).Richtung = 1
    
    Gegner(29).X = 24
    Gegner(29).Z = -415
    Gegner(29).Typ = 21
    Gegner(29).Armor = 8
    Gegner(29).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(30).X = 40
    Gegner(30).Z = -485
    Gegner(30).Typ = 13
    Gegner(30).Armor = 9
    Gegner(30).Richtung = 1
    
    Gegner(31).X = 38
    Gegner(31).Z = -495
    Gegner(31).Typ = 13
    Gegner(31).Armor = 9
    Gegner(31).Richtung = 1

    Gegner(32).X = 42
    Gegner(32).Z = -505
    Gegner(32).Typ = 13
    Gegner(32).Armor = 9                                '7
    Gegner(32).Richtung = 1
    
    Gegner(33).X = 26
    Gegner(33).Z = -500
    Gegner(33).Typ = 13
    Gegner(33).Armor = 9
    Gegner(33).Richtung = 0
    
    Gegner(34).X = 30
    Gegner(34).Z = -490
    Gegner(34).Typ = 13
    Gegner(34).Armor = 9
    Gegner(34).Richtung = 0
    
    Gegner(35).X = 28
    Gegner(35).Z = -480
    Gegner(35).Typ = 13
    Gegner(35).Armor = 9
    Gegner(35).Richtung = 0
    '------------------------------------------------------------------------
    Gegner(36).X = 36
    Gegner(36).Z = -560
    Gegner(36).Typ = 13
    Gegner(36).Armor = 9
    Gegner(36).Richtung = 1
    
    Gegner(37).X = 34
    Gegner(37).Z = -570
    Gegner(37).Typ = 13
    Gegner(37).Armor = 9
    Gegner(37).Richtung = 1
    
    Gegner(38).X = 32
    Gegner(38).Z = -560
    Gegner(38).Typ = 13
    Gegner(38).Armor = 9                            '8
    Gegner(38).Richtung = 1
    
    Gegner(39).X = 38
    Gegner(39).Z = -600
    Gegner(39).Typ = 13
    Gegner(39).Armor = 9
    
    Gegner(40).X = 34
    Gegner(40).Z = -620
    Gegner(40).Typ = 13
    Gegner(40).Armor = 9
    
    Gegner(41).X = 30
    Gegner(41).Z = -600
    Gegner(41).Typ = 13
    Gegner(41).Armor = 9
    '------------------------------------------------------------------------
    
    For i = 0 To 41
        If s_Schwierigkeitsgrad = "schwer" Then
            Gegner(i).Armor = Gegner(i).Armor * 1.5
        ElseIf s_Schwierigkeitsgrad = "mittel" Then
            Gegner(i).Armor = Gegner(i).Armor * 1
        ElseIf s_Schwierigkeitsgrad = "leicht" Then
            Gegner(i).Armor = Gegner(i).Armor * 0.5
        ElseIf s_Schwierigkeitsgrad = "massaker" Then
            Gegner(i).Armor = 1
        End If
        Gegner(i).Typsave = Gegner(i).Typ
        Gegner(i).Armorsave = Gegner(i).Armor
    Next i
End Sub

Public Sub Prepare_level5()
    Dim i As Integer

    EscRun = 0
    Gedrckt(13) = 0
    D3DDevice.LightEnable 0, 1
    D3DDevice.LightEnable 1, 0
    SetLevel(0) = 0
    SetLevel(1) = 132
    For i = 0 To 10
        Explosion(i).Gone = 100
    Next i
    
    PlayerX = 0
    RaketenNachladen = 15
    Player.X = 34
    Player.Y = 10
    Player.Z = 127
    Player.Typ = s_Raumschiff.Typ
    Player.Acceleration = 0
    Player.Energy = s_Raumschiff.Energy
    Player.Reactor = s_Raumschiff.Reactor
    Player.MaxTempo = s_Raumschiff.MaxTempo
    Player.Armor = s_Raumschiff.Armor
    Player.Tempo = 200
    Primary.Frequency = s_Primary.Frequency
    Primary.Power = s_Primary.Power
    Primary.Typ = s_Primary.Typ
    
    Call CheckExtras
    
    For i = 0 To 50
        Gegner(i).Y = 10
        Gegner(i).Typ = 0
    Next i
    
    
    Gimmick(0).X = 29
    Gimmick(0).Y = 3
    Gimmick(0).Z = 0
    Gimmick(0).Typ = 36
    Gimmick(0).Rotation = Int(Rnd * 360)
    
    Gimmick(1).X = 24
    Gimmick(1).Y = 3
    Gimmick(1).Z = -25
    Gimmick(1).Typ = 37
    Gimmick(1).Rotation = Int(Rnd * 360)
    
    Gimmick(2).X = 40
    Gimmick(2).Y = 3
    Gimmick(2).Z = -50
    Gimmick(2).Typ = 37
    Gimmick(2).Rotation = Int(Rnd * 360)
    
    Gimmick(3).X = 35
    Gimmick(3).Y = 3
    Gimmick(3).Z = -75
    Gimmick(3).Typ = 37
    Gimmick(3).Rotation = Int(Rnd * 360)
    
    Gimmick(4).X = 45
    Gimmick(4).Y = 3
    Gimmick(4).Z = -100
    Gimmick(4).Typ = 36
    Gimmick(4).Rotation = Int(Rnd * 360)
    
    Gimmick(5).Typ = 0
    Gimmick(6).Typ = 0
    Gimmick(7).Typ = 0
    Gimmick(8).Typ = 0
    Gimmick(9).Typ = 0
    Gimmick(10).Typ = 0
    
    '------------------------------------------------------------------------
    Gegner(0).X = 32
    Gegner(0).Z = 0
    Gegner(0).Typ = 15
    Gegner(0).Armor = 9
    
    Gegner(1).X = 38
    Gegner(1).Z = -10                                   '1
    Gegner(1).Typ = 15
    Gegner(1).Armor = 9
    
    Gegner(2).X = 34
    Gegner(2).Z = -20
    Gegner(2).Typ = 15
    Gegner(2).Armor = 9
    '------------------------------------------------------------------------
    Gegner(3).X = 34
    Gegner(3).Z = -110
    Gegner(3).Typ = 15
    Gegner(3).Armor = 9
    
    Gegner(4).X = 32
    Gegner(4).Z = -120                                   '2
    Gegner(4).Typ = 15
    Gegner(4).Armor = 9
    
    Gegner(5).X = 30
    Gegner(5).Z = -130
    Gegner(5).Typ = 15
    Gegner(5).Armor = 9
    '------------------------------------------------------------------------
    Gegner(6).X = 34
    Gegner(6).Z = -190
    Gegner(6).Typ = 15
    Gegner(6).Armor = 9
    
    Gegner(7).X = 36
    Gegner(7).Z = -200                                   '3
    Gegner(7).Typ = 15
    Gegner(7).Armor = 9
    
    Gegner(8).X = 38
    Gegner(8).Z = -210
    Gegner(8).Typ = 15
    Gegner(8).Armor = 9
    '------------------------------------------------------------------------
    Gegner(9).X = 42
    Gegner(9).Z = -260
    Gegner(9).Typ = 15
    Gegner(9).Armor = 9
    
    Gegner(10).X = 40
    Gegner(10).Z = -270                                 '4
    Gegner(10).Typ = 15
    Gegner(10).Armor = 9
    
    Gegner(11).X = 38
    Gegner(11).Z = -280
    Gegner(11).Typ = 15
    Gegner(11).Armor = 9
    '------------------------------------------------------------------------
    Gegner(12).X = 44
    Gegner(12).Z = -330
    Gegner(12).Typ = 15
    Gegner(12).Armor = 9
    Gegner(12).Richtung = 0
    
    Gegner(13).X = 42
    Gegner(13).Z = -340
    Gegner(13).Typ = 15
    Gegner(13).Armor = 9                                '5
    Gegner(13).Richtung = 0
    
    Gegner(14).X = 40
    Gegner(14).Z = -350
    Gegner(14).Typ = 15
    Gegner(14).Armor = 9
    Gegner(14).Richtung = 0
    
    Gegner(15).X = 28
    Gegner(15).Z = -355
    Gegner(15).Typ = 15
    Gegner(15).Armor = 9
    Gegner(15).Richtung = 1
    
    Gegner(16).X = 26
    Gegner(16).Z = -345
    Gegner(16).Typ = 15
    Gegner(16).Armor = 9
    Gegner(16).Richtung = 1
    
    Gegner(17).X = 24
    Gegner(17).Z = -335
    Gegner(17).Typ = 15
    Gegner(17).Armor = 9
    Gegner(17).Richtung = 1
    
    '------------------------------------------------------------------------
    Gegner(18).X = 46
    Gegner(18).Z = -420
    Gegner(18).Typ = 17
    Gegner(18).Armor = 10
    
    Gegner(19).X = 42
    Gegner(19).Z = -420
    Gegner(19).Typ = 17
    Gegner(19).Armor = 10
    
    Gegner(20).X = 38
    Gegner(20).Z = -410
    Gegner(20).Typ = 17
    Gegner(20).Armor = 10                                '6
    
    Gegner(21).X = 34
    Gegner(21).Z = -410
    Gegner(21).Typ = 17
    Gegner(21).Armor = 10
    
    Gegner(22).X = 30
    Gegner(22).Z = -410
    Gegner(22).Typ = 17
    Gegner(22).Armor = 10
    
    Gegner(23).X = 26
    Gegner(23).Z = -420
    Gegner(23).Typ = 17
    Gegner(23).Armor = 10
    
    Gegner(24).X = 22
    Gegner(24).Z = -420
    Gegner(24).Typ = 17
    Gegner(24).Armor = 10
    '------------------------------------------------------------------------
    Gegner(25).X = 40
    Gegner(25).Z = -485
    Gegner(25).Typ = 17
    Gegner(25).Armor = 10
    Gegner(25).Richtung = 0
    
    Gegner(26).X = 38
    Gegner(26).Z = -495
    Gegner(26).Typ = 17
    Gegner(26).Armor = 10
    Gegner(26).Richtung = 0
    
    Gegner(27).X = 36
    Gegner(27).Z = -505
    Gegner(27).Typ = 17
    Gegner(27).Armor = 10
    Gegner(27).Richtung = 0                             '7
    
    Gegner(28).X = 34
    Gegner(28).Z = -520
    Gegner(28).Typ = 17
    Gegner(28).Armor = 10
    
    Gegner(29).X = 32
    Gegner(29).Z = -510
    Gegner(29).Typ = 17
    Gegner(29).Armor = 10
    Gegner(29).Richtung = 1
    
    Gegner(30).X = 30
    Gegner(30).Z = -500
    Gegner(30).Typ = 17
    Gegner(30).Armor = 10
    Gegner(30).Richtung = 1
    
    Gegner(31).X = 28
    Gegner(31).Z = -490
    Gegner(31).Typ = 17
    Gegner(31).Armor = 10
    Gegner(31).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(32).X = 40
    Gegner(32).Z = -600
    Gegner(32).Typ = 23
    Gegner(32).Armor = 11
    Gegner(32).Richtung = 0
    
    Gegner(33).X = 38
    Gegner(33).Z = -590
    Gegner(33).Typ = 23
    Gegner(33).Armor = 11
    Gegner(33).Richtung = 0
    
    Gegner(34).X = 36
    Gegner(34).Z = -580
    Gegner(34).Typ = 23
    Gegner(34).Armor = 11
    Gegner(34).Richtung = 0                            '8
    
    Gegner(35).X = 34
    Gegner(35).Z = -570
    Gegner(35).Typ = 23
    Gegner(35).Armor = 11
    
    Gegner(36).X = 32
    Gegner(36).Z = -585
    Gegner(36).Typ = 23
    Gegner(36).Armor = 11
    Gegner(36).Richtung = 1
    
    Gegner(37).X = 30
    Gegner(37).Z = -595
    Gegner(37).Typ = 23
    Gegner(37).Armor = 11
    Gegner(37).Richtung = 1
    
    Gegner(38).X = 28
    Gegner(38).Z = -605
    Gegner(38).Typ = 23
    Gegner(38).Armor = 11
    Gegner(38).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(39).X = 34
    Gegner(39).Z = -650
    Gegner(39).Typ = 23
    Gegner(39).Armor = 11
    Gegner(39).Richtung = 1
    
    Gegner(40).X = 34
    Gegner(40).Z = -660
    Gegner(40).Typ = 23
    Gegner(40).Armor = 11
    Gegner(40).Richtung = 1
    
    Gegner(41).X = 36
    Gegner(41).Z = -670
    Gegner(41).Typ = 23
    Gegner(41).Armor = 11                                '9
    Gegner(41).Richtung = 1
    
    Gegner(42).X = 38
    Gegner(42).Z = -680
    Gegner(42).Typ = 23
    Gegner(42).Armor = 11
    Gegner(42).Richtung = 1
    '------------------------------------------------------------------------
    Gegner(43).X = 34
    Gegner(43).Z = -720
    Gegner(43).Typ = 23
    Gegner(43).Armor = 11
    Gegner(43).Richtung = 0
    
    Gegner(44).X = 34
    Gegner(44).Z = -730
    Gegner(44).Typ = 23
    Gegner(44).Armor = 11
    Gegner(44).Richtung = 0
    
    Gegner(45).X = 32
    Gegner(45).Z = -740
    Gegner(45).Typ = 23
    Gegner(45).Armor = 11
    Gegner(45).Richtung = 0                                 '10
    
    Gegner(46).X = 30
    Gegner(46).Z = -750
    Gegner(46).Typ = 23
    Gegner(46).Armor = 11
    Gegner(46).Richtung = 0
    
    For i = 0 To 46
        If s_Schwierigkeitsgrad = "schwer" Then
            Gegner(i).Armor = Gegner(i).Armor * 1.5
        ElseIf s_Schwierigkeitsgrad = "mittel" Then
            Gegner(i).Armor = Gegner(i).Armor * 1
        ElseIf s_Schwierigkeitsgrad = "leicht" Then
            Gegner(i).Armor = Gegner(i).Armor * 0.5
        ElseIf s_Schwierigkeitsgrad = "massaker" Then
            Gegner(i).Armor = 1
        End If
        Gegner(i).Typsave = Gegner(i).Typ
        Gegner(i).Armorsave = Gegner(i).Armor
    Next i
End Sub

Public Sub Fly_Level1()
    Dim i As Integer, j As Integer
    
    For i = 0 To 50
        If gShotPause(i) > 0 Then gShotPause(i) = gShotPause(i) + ((30 / FPS_Current) * 0.1)
        If gShotPause(i) >= 5.5 Then gShotPause(i) = 0

        If gShotPause(i) = 0 And Gegner(i).Z <= Player.Z And Gegner(i).Z >= Player.Z - 100 And Gegner(i).Typ <> 0 And (Gegner(i).Vibration < 3 And Gegner(i).Vibration > -3) Then
            If Int(Rnd * 25) = 2 Then
                gShotPause(i) = 0.1
                For j = 0 To 100
                    If gShot(j).Typ = 0 Then
                        gShot(j).X = Gegner(i).X
                        gShot(j).Y = Gegner(i).Y    'Schussposition
                        gShot(j).Z = Gegner(i).Z
                        gShot(j).vZ = 1
                        gShot(j).vY = 0  'Schussvektor
                        gShot(j).vX = 0
                        If Gegner(i).Typ = 16 Then
                            gShot(j).Typ = 6
                            gShot(j).Power = 0.5
                        ElseIf Gegner(i).Typ = 22 Then
                            gShot(j).Typ = 2
                            gShot(j).Power = 1
                        ElseIf Gegner(i).Typ = 38 Then
                            gShot(j).Typ = 5
                            gShot(j).Power = 1.5
                        End If
                        gShot(j).Shoot = 0
                        Exit For
                    End If
                Next j
            End If
        End If
    Next i
    
    For i = 12 To 17
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 25 To 27
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 29 To 31
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 32 To 34
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 36 To 38
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    
    For i = 0 To 50
        Gegner(i).Z = Gegner(i).Z + ((30 / FPS_Current) * 0.18)
    Next i
End Sub

Public Sub Gimmicks_level1(move As Single)
    Dim i As Integer

    For i = 0 To 5
        Gimmick(i).Y = (Sin(Gimmick(i).X + move) / 5) + 5.5
    Next i
End Sub

Public Sub Fly_Level2()
    Dim i As Integer, j As Integer
    
    For i = 0 To 50
        If gShotPause(i) > 0 Then gShotPause(i) = gShotPause(i) + ((30 / FPS_Current) * 0.1)
        If gShotPause(i) >= 5 Then gShotPause(i) = 0

        If Gegner(i).Z <= Player.Z And gShotPause(i) = 0 And Gegner(i).Z >= Player.Z - 100 And Gegner(i).Typ <> 0 And (Gegner(i).Vibration < 3 And Gegner(i).Vibration > -3) Then
            If Int(Rnd * 25) = 2 Then
                gShotPause(i) = 1
                For j = 0 To 100
                    If gShot(j).Typ = 0 Then
                        gShot(j).X = Gegner(i).X
                        gShot(j).Y = Gegner(i).Y    'Schussposition
                        gShot(j).Z = Gegner(i).Z
                        gShot(j).vZ = 1
                        gShot(j).vY = 0  'Schussvektor
                        gShot(j).vX = 0
                        If Gegner(i).Typ = 19 Then
                            gShot(j).Typ = 6
                            gShot(j).Power = 1
                        ElseIf Gegner(i).Typ = 25 Then
                            gShot(j).Typ = 2
                            gShot(j).Power = 1.5
                        ElseIf Gegner(i).Typ = 26 Then
                            gShot(j).Typ = 5
                            gShot(j).Power = 2
                        End If
                        gShot(j).Shoot = 0
                        Exit For
                    End If
                Next j
            End If
        End If
    Next i
    
    For i = 9 To 14
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 19 To 23
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 30 To 35
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    
    For i = 0 To 50
        Gegner(i).Z = Gegner(i).Z + ((30 / FPS_Current) * 0.18)
    Next i
End Sub

Public Sub Gimmicks_level2(move As Single)
    Dim i As Integer

    For i = 0 To 50
        Gimmick(i).Y = (Sin(Gimmick(i).X + move) / 5) + 5.5
    Next i
End Sub

Public Sub Fly_Level3()
    Dim i As Integer, j As Integer
    
    For i = 0 To 50
        If gShotPause(i) > 0 Then gShotPause(i) = gShotPause(i) + ((30 / FPS_Current) * 0.1)
        If gShotPause(i) >= 4.5 Then gShotPause(i) = 0

        If Gegner(i).Z <= Player.Z And gShotPause(i) = 0 And Gegner(i).Z >= Player.Z - 100 And Gegner(i).Typ <> 0 And (Gegner(i).Vibration < 3 And Gegner(i).Vibration > -3) Then
            If Int(Rnd * 25) = 2 Then
                gShotPause(i) = 1
                For j = 0 To 100
                    If gShot(j).Typ = 0 Then
                        gShot(j).X = Gegner(i).X
                        gShot(j).Y = Gegner(i).Y    'Schussposition
                        gShot(j).Z = Gegner(i).Z
                        gShot(j).vZ = 1
                        gShot(j).vY = 0  'Schussvektor
                        gShot(j).vX = 0
                        If Gegner(i).Typ = 18 Then
                            gShot(j).Typ = 6
                            gShot(j).Power = 1.5
                        ElseIf Gegner(i).Typ = 20 Then
                            gShot(j).Typ = 2
                            gShot(j).Power = 2
                        ElseIf Gegner(i).Typ = 24 Then
                            gShot(j).Typ = 5
                            gShot(j).Power = 2.5
                        End If
                        gShot(j).Shoot = 0
                        Exit For
                    End If
                Next j
            End If
        End If
    Next i
    
    For i = 12 To 17
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 25 To 27
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 29 To 31
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 32 To 34
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 36 To 38
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 39 To 46
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 0 To 50
        Gegner(i).Z = Gegner(i).Z + ((30 / FPS_Current) * 0.18)
    Next i
End Sub

Public Sub Gimmicks_level3(move As Single)
'    Dim i As Integer
'
'    For i = 0 To 50
'        Gimmick(i).Y = (Sin(Gimmick(i).X + move) / 5) + 5
'    Next i
End Sub

Public Sub Fly_Level4()
    Dim i As Integer, j As Integer
    
    For i = 0 To 50
        If gShotPause(i) > 0 Then gShotPause(i) = gShotPause(i) + ((30 / FPS_Current) * 0.1)
        If gShotPause(i) >= 4 Then gShotPause(i) = 0

        If Gegner(i).Z <= Player.Z And gShotPause(i) = 0 And Gegner(i).Z >= Player.Z - 100 And Gegner(i).Typ <> 0 And (Gegner(i).Vibration < 3 And Gegner(i).Vibration > -3) Then
            If Int(Rnd * 25) = 2 Then
                gShotPause(i) = 1
                For j = 0 To 100
                    If gShot(j).Typ = 0 Then
                        gShot(j).X = Gegner(i).X
                        gShot(j).Y = Gegner(i).Y    'Schussposition
                        gShot(j).Z = Gegner(i).Z
                        gShot(j).vZ = 1
                        gShot(j).vY = 0  'Schussvektor
                        gShot(j).vX = 0
                        If Gegner(i).Typ = 14 Then
                            gShot(j).Typ = 1
                            gShot(j).Power = 2
                        ElseIf Gegner(i).Typ = 21 Then
                            gShot(j).Typ = 2
                            gShot(j).Power = 2.5
                        ElseIf Gegner(i).Typ = 13 Then
                            gShot(j).Typ = 5
                            gShot(j).Power = 3
                        End If
                        gShot(j).Shoot = 0
                        Exit For
                    End If
                Next j
            End If
        End If
    Next i
    
    For i = 9 To 14
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 19 To 23
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 30 To 35
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    
    For i = 0 To 50
        Gegner(i).Z = Gegner(i).Z + ((30 / FPS_Current) * 0.18)
    Next i
End Sub

Public Sub Gimmicks_level4(move As Single)
'    Dim i As Integer
'
'    For i = 0 To 50
'        Gimmick(i).Y = (Sin(Gimmick(i).X + move) / 5) + 5
'    Next i
End Sub

Public Sub Fly_Level5()
    Dim i As Integer, j As Integer
    
    For i = 0 To 50
        If gShotPause(i) > 0 Then gShotPause(i) = gShotPause(i) + ((30 / FPS_Current) * 0.1)
        If gShotPause(i) >= 3.5 Then gShotPause(i) = 0

        If Gegner(i).Z <= Player.Z And gShotPause(i) = 0 And Gegner(i).Z >= Player.Z - 100 And Gegner(i).Typ <> 0 And (Gegner(i).Vibration < 3 And Gegner(i).Vibration > -3) Then
            If Int(Rnd * 25) = 2 Then
                gShotPause(i) = 1
                For j = 0 To 100
                    If gShot(j).Typ = 0 Then
                        gShot(j).X = Gegner(i).X
                        gShot(j).Y = Gegner(i).Y    'Schussposition
                        gShot(j).Z = Gegner(i).Z
                        gShot(j).vZ = 1
                        gShot(j).vY = 0  'Schussvektor
                        gShot(j).vX = 0
                        If Gegner(i).Typ = 15 Then
                            gShot(j).Typ = 1
                            gShot(j).Power = 2.5
                        ElseIf Gegner(i).Typ = 17 Then
                            gShot(j).Typ = 4
                            gShot(j).Power = 3
                        ElseIf Gegner(i).Typ = 23 Then
                            gShot(j).Typ = 5
                            gShot(j).Power = 3.5
                        End If
                        gShot(j).Shoot = 0
                        Exit For
                    End If
                Next j
            End If
        End If
    Next i
    
    For i = 12 To 17
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 25 To 27
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 29 To 31
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 32 To 34
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 36 To 38
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    For i = 39 To 46
        If Gegner(i).Richtung = 0 Then
            Gegner(i).X = Gegner(i).X - ((30 / FPS_Current) * 0.1)
            If Gegner(i).X <= 22 Then Gegner(i).Richtung = 1
        ElseIf Gegner(i).Richtung = 1 Then
            Gegner(i).X = Gegner(i).X + ((30 / FPS_Current) * 0.1)
            If Gegner(i).X >= 46 Then Gegner(i).Richtung = 0
        End If
    Next i
    
    For i = 0 To 50
        Gegner(i).Z = Gegner(i).Z + ((30 / FPS_Current) * 0.18)
    Next i
End Sub

Public Sub Gimmicks_level5(move As Single)
    Gimmick(0).RotationZ = move / 4
    Gimmick(4).RotationZ = move / 5
End Sub

Public Sub Work_Level(moves As Single, WaveMove As Single, Auswahl As String)
    Dim i As Integer, j As Integer, k As Integer, Rndcount As Integer _
    , test As Boolean, l As Integer, Buffer As Single, Vapor As Single

    '###############Gegnersteuerung Anfang##############
    For i = 0 To 50
        If Gegner(i).Z >= Player.Z + 30 And Gegner(i).Lifes < 2 Then
            If Auswahl = "level1" Then
                Gegner(i).Z = Gegner(i).Z - 780
            ElseIf Auswahl = "level2" Then
                Gegner(i).Z = Gegner(i).Z - 650
            ElseIf Auswahl = "level3" Then
                Gegner(i).Z = Gegner(i).Z - 780
            ElseIf Auswahl = "level4" Then
                Gegner(i).Z = Gegner(i).Z - 650
            ElseIf Auswahl = "level5" Then
                Gegner(i).Z = Gegner(i).Z - 780
            End If
            Gegner(i).Typ = Gegner(i).Typsave
            Gegner(i).Armor = Gegner(i).Armorsave
            Gegner(i).Lifes = Gegner(i).Lifes + 1
        End If
    Next i
    
    For i = 0 To 50
        If Gimmick(i).Z >= Player.Z + 25 Then
            If Auswahl = "level5" Then
                Gimmick(i).Z = Gimmick(i).Z - 170
            End If
            If Auswahl = "level4" Then
                Gimmick(i).Z = Gimmick(i).Z - 170
            End If
            If Auswahl = "level3" Then
                Gimmick(i).Z = Gimmick(i).Z - 170
            End If
            If Auswahl = "level2" Then
                Gimmick(i).Z = Gimmick(i).Z - 170
            End If
            If Auswahl = "level1" Then
                Gimmick(i).Z = Gimmick(i).Z - 170
            End If
        End If
    Next i
    
    If Auswahl = "level1" Then
        Fly_Level1
    ElseIf Auswahl = "level2" Then
        Fly_Level2
    ElseIf Auswahl = "level3" Then
        Fly_Level3
    ElseIf Auswahl = "level4" Then
        Fly_Level4
    ElseIf Auswahl = "level5" Then
        Fly_Level5
    End If
    
    For i = 0 To 50
        If Gegner(i).Vibration >= 0 Then
            Gegner(i).Vibration = Gegner(i).Vibration - (30 / FPS_Current) * 0.2
        End If
        If Gegner(i).Vibration <= 0 Then
            Gegner(i).Vibration = Gegner(i).Vibration + (30 / FPS_Current) * 0.2
        End If
    Next i

    '###############Gegnersteuerung Ende##############
    
    '###############Segmentaufbau Anfang##################
    LevelMove = LevelMove + ((30 / FPS_Current) * (Player.Tempo / 2000))
    If LevelMove >= 131 Then
        SetLevel(Levelknown) = SetLevel(Levelknown) + 131 * 2
        If Levelknown = 1 Then
            Levelknown = 0
        Else
            Levelknown = 1
        End If
        LevelMove = 0
    End If
    '###############Segmentaufbau Ende##################
    
    '###############Playersteuerung Anfang##############
    Player.Z = Player.Z - ((30 / FPS_Current) * (Player.Tempo / 2000)) ' 200km/h : 2000
    Repair = Repair + (30 / FPS_Current) * 0.006
    If RepairEinheit = True And Repair >= 10 Then
        If Player.Armor < Player.Energy Then Player.Armor = Player.Armor + 1
        Repair = 0
    End If
    
    If Gedrckt(38) And Player.Tempo <= Player.MaxTempo Then
        Player.Tempo = Int(Player.Tempo + (30 / FPS_Current))
    End If
    If Gedrckt(40) And Player.Tempo >= 150 Then
        Player.Tempo = Int(Player.Tempo - (30 / FPS_Current))
    End If
    
    '89, 88 -> y, x
    
    If DriftPause > 0 Then DriftPause = DriftPause + ((30 / FPS_Current) * 0.1)
    If DriftPause >= 5 Then DriftPause = 0
    
    If Gedrckt(89) And Ausweichdsen = True And Player.Drift < 0.5 And DriftPause = 0 Then
        DriftPause = 1
        Player.Drift = 2
        DSDrift(0).SetCurrentPosition 0
        DSDrift(0).Play DSBPLAY_DEFAULT
    End If
    If Gedrckt(88) And Ausweichdsen = True And Player.Drift > -0.5 And DriftPause = 0 Then
        DriftPause = 1
        Player.Drift = -2
        DSDrift(0).SetCurrentPosition 0
        DSDrift(0).Play DSBPLAY_DEFAULT
    End If
    
    If Player.Drift > 0 Then
        Player.Drift = Player.Drift - (30 / FPS_Current) * 0.1
    Else
        Player.Drift = Player.Drift + (30 / FPS_Current) * 0.1
    End If
    
    If Player.Drift < -0.5 Then
        Player.Acceleration = Player.Acceleration + (30 / FPS_Current) * 0.005
        For i = 0 To 2
            For j = 0 To 1000
                If Smoke(j).Typ = 0 Then
                    Smoke(j).Typ = 1
                    Smoke(j).Y = Player.Y
                    Smoke(j).Z = Player.Z + Rnd * 0.5 - 0.5
                    Smoke(j).X = Player.X + 0.7
                    Smoke(j).Gone = 0
                    Exit For
                End If
            Next j
        Next i
    ElseIf Player.Drift > 0.5 Then
        Player.Acceleration = Player.Acceleration - (30 / FPS_Current) * 0.005
        For i = 0 To 2
            For j = 0 To 1000
                If Smoke(j).Typ = 0 Then
                    Smoke(j).Typ = 1
                    Smoke(j).Y = Player.Y
                    Smoke(j).Z = Player.Z + Rnd * 0.5 - 0.5
                    Smoke(j).X = Player.X - 0.7
                    Smoke(j).Gone = 0
                    Exit For
                End If
            Next j
        Next i
    End If
    
    If Player.Acceleration > 0.03 Then
        Player.Acceleration = 0.03
    ElseIf Player.Acceleration < -0.03 Then
        Player.Acceleration = -0.03
    End If
    
    If Gedrckt(37) And Player.Acceleration > -0.03 Then
        Player.Acceleration = Player.Acceleration - ((30 / FPS_Current) * 0.001)
        If Player.Acceleration > 0.002 Then
            Player.Acceleration = Player.Acceleration - ((30 / FPS_Current) * 0.001)
        End If
    ElseIf Gedrckt(39) And Player.Acceleration < 0.03 Then
        Player.Acceleration = Player.Acceleration + ((30 / FPS_Current) * 0.001)
        If Player.Acceleration < -0.002 Then
            Player.Acceleration = Player.Acceleration + ((30 / FPS_Current) * 0.001)
        End If
    ElseIf Gedrckt(37) Or Gedrckt(39) Then
            'verhindert Ruckeln
    Else
        If Player.Acceleration < -0.0044 Then
            Player.Acceleration = Player.Acceleration + ((30 / FPS_Current) * 0.002)
        ElseIf Player.Acceleration > 0.0044 Then
            Player.Acceleration = Player.Acceleration - ((30 / FPS_Current) * 0.002)
        Else
            'PlayerAcc = 0
        End If
    End If
    If PlayerX + ((30 / FPS_Current) * Player.Acceleration) <= 2 And PlayerX + ((30 / FPS_Current) * Player.Acceleration) >= -2 Then
        PlayerX = PlayerX + ((30 / FPS_Current) * Player.Acceleration)
    Else
        If Player.Acceleration > 0 Then
            PlayerX = 2
        ElseIf Player.Acceleration < 0 Then
            PlayerX = -2
        End If
    End If
    Player.X = 34 - PlayerX * 6
    '###############Playersteuerung Ende##############
    
    '###############Rauchaussto Ende##############
    If SmokePause > 0 Then SmokePause = SmokePause + ((30 / FPS_Current) * 0.1)
    If SmokePause >= 1.5 Then SmokePause = 0
    
    If SmokePause = 0 Then
        SmokePause = 1
        For i = 0 To 3
            If Player.Typ <> 0 Then
                For j = 0 To 1000
                    If Smoke(j).Typ = 0 Then
                        Smoke(j).Typ = 1
                        Smoke(j).Y = Player.Y + Rnd * 0.5 - 0.25
                        Smoke(j).Z = Player.Z + 1.5
                        Rndcount = Int(Rnd * 2)
                        If Player.Typ = 1 Then Vapor = 0
                        If Player.Typ = 2 Then Vapor = 0.4
                        If Player.Typ = 3 Then Vapor = 0.3
                        If Player.Typ = 4 Then Vapor = 0.4
                        If Player.Typ = 5 Then Vapor = 0
                        If Player.Acceleration < 0 Then
                            If Rndcount = 1 Then
                                Smoke(j).X = Player.X + Rnd * 0.3 + (Vapor + Player.Acceleration * 20)
                            Else
                                Smoke(j).X = Player.X - Rnd * 0.3 - (Vapor + Player.Acceleration * 20)
                            End If
                        Else
                            If Rndcount = 1 Then
                                Smoke(j).X = Player.X + Rnd * 0.3 + (Vapor + Player.Acceleration * -20)
                            Else
                                Smoke(j).X = Player.X - Rnd * 0.3 - (Vapor + Player.Acceleration * -20)
                            End If
                        End If
                        Smoke(j).Gone = 0
                        Exit For
                    End If
                Next j
            End If
            For k = 0 To 50
                If Gegner(k).Typ <> 0 And Gegner(k).Z <= Player.Z And Gegner(k).Z >= Player.Z - 100 Then
                    For j = 0 To 1000
                        If Smoke(j).Typ = 0 Then
                            Smoke(j).Typ = 1
                            Smoke(j).Y = Gegner(k).Y + Rnd * 0.5 - 0.25
                            Smoke(j).Z = Gegner(k).Z - 1.5
                            Rndcount = Int(Rnd * 2)
                            If Rndcount = 1 Then
                                Smoke(j).X = Gegner(k).X + Rnd * 0.3 + 0.4
                            Else
                                Smoke(j).X = Gegner(k).X - Rnd * 0.3 - 0.4
                            End If
                            Smoke(j).Gone = 0
                            Exit For
                        End If
                    Next j
                End If
            Next k
            For k = 0 To 20
                If Rakete(k).Typ <> 0 Then
                    For j = 0 To 1000
                        If Smoke(j).Typ = 0 Then
                            Smoke(j).Typ = 1
                            Smoke(j).Y = Rakete(k).Y + Rnd * 0.5 - 0.25
                            Smoke(j).Z = Rakete(k).Z
                            Smoke(j).X = Rakete(k).X + Rnd * 0.3 - 0.1
                            Smoke(j).Gone = 0
                            Exit For
                        End If
                    Next j
                End If
            Next k
        Next i
        For i = 0 To 1000
            If Smoke(i).Typ <> 0 Then
                Smoke(i).Gone = Smoke(i).Gone + ((30 / FPS_Current) * 5)
                If Smoke(i).Gone > 100 Then
                    Smoke(i).Typ = 0
                End If
            End If
        Next i
    End If
    '###############Rauchaussto Ende##############
    
    '###############Schieen Anfang###################
    If ShotPause > 0 Then ShotPause = ShotPause + ((30 / FPS_Current) * Primary.Frequency)
    If ShotPause >= 5 Then ShotPause = 0
    
    If Gedrckt(32) And ShotPause = 0 Then
        Shoted = Shoted + 1
        ShotPause = 1
        For i = 0 To 100
            If Shot(i).Typ = 0 Then
                Shot(i).X = Player.X
                Shot(i).Y = Player.Y    'Schussposition
                Shot(i).Z = Player.Z
                Shot(i).vZ = -1
                Shot(i).vY = 0  'Schussvektor
                Shot(i).vX = 0
                Shot(i).Typ = Primary.Typ
                Shot(i).Power = Primary.Power
                Shot(i).Shoot = 0
                If Primary.Typ = 4 Then
                    Shot(i).Rotation = Player.Acceleration
                Else
                    Shot(i).Rotation = 0
                End If
                
                If Primary.Typ = 1 Then
                    DSPlasma.SetCurrentPosition 0
                    DSPlasma.Play DSBPLAY_DEFAULT
                ElseIf Primary.Typ = 2 Then
                    DSLaserkatapult.SetCurrentPosition 0
                    DSLaserkatapult.Play DSBPLAY_DEFAULT
                ElseIf Primary.Typ = 3 Then
                    DSLaser.SetCurrentPosition 0
                    DSLaser.Play DSBPLAY_DEFAULT
                ElseIf Primary.Typ = 4 Then
                    DSEnergiediskus.SetCurrentPosition 0
                    DSEnergiediskus.Play DSBPLAY_DEFAULT
                ElseIf Primary.Typ = 5 Then
                    DSGun.SetCurrentPosition 0
                    DSGun.Play DSBPLAY_DEFAULT
                End If
                Exit For
            End If
        Next i
    End If
    For i = 0 To 100
        If Shot(i).Typ <> 0 Then
            If Shot(i).Typ <> 3 Then Shot(i).Z = Shot(i).Z + (30 / FPS_Current) * ((Shot(i).vZ / (Sqr(Shot(i).vX ^ 2 + Shot(i).vY ^ 2 + Shot(i).vZ ^ 2))))
            Shot(i).Y = Shot(i).Y + (30 / FPS_Current) * ((Shot(i).vY / (Sqr(Shot(i).vX ^ 2 + Shot(i).vY ^ 2 + Shot(i).vZ ^ 2))))
            Shot(i).X = Shot(i).X + (30 / FPS_Current) * ((Shot(i).vX / (Sqr(Shot(i).vX ^ 2 + Shot(i).vY ^ 2 + Shot(i).vZ ^ 2))))
            If Shot(i).Typ = 3 Then
                Shot(i).Z = Shot(i).Z - ((30 / FPS_Current) * 0.1)
                Shot(i).Shoot = Shot(i).Shoot + ((30 / FPS_Current) * 3)
            Else
                Shot(i).Shoot = Shot(i).Shoot + ((30 / FPS_Current) * 0.5)
            End If
            If Shot(i).Typ = 3 And Shot(i).Shoot >= 100 Then
                Shot(i).Typ = 0
            End If
            If Shot(i).Typ <> 3 And Shot(i).Shoot >= 70 Then
                Shot(i).Typ = 0
            End If
        End If
    Next i
    '###############Schieen Ende###################
    
    '###############Gegnerschieen Anfang###################
    For i = 0 To 100
        If gShot(i).Typ <> 0 Then
            gShot(i).Z = gShot(i).Z + (30 / FPS_Current) * (((gShot(i).vZ / (Sqr(gShot(i).vX ^ 2 + gShot(i).vY ^ 2 + gShot(i).vZ ^ 2)))) * 0.7)
            gShot(i).Y = gShot(i).Y + (30 / FPS_Current) * (((gShot(i).vY / (Sqr(gShot(i).vX ^ 2 + gShot(i).vY ^ 2 + gShot(i).vZ ^ 2)))) * 0.7)
            gShot(i).X = gShot(i).X + (30 / FPS_Current) * (((gShot(i).vX / (Sqr(gShot(i).vX ^ 2 + gShot(i).vY ^ 2 + gShot(i).vZ ^ 2)))) * 0.7)
            
            gShot(i).Shoot = gShot(i).Shoot + ((30 / FPS_Current) * 0.7)
            If gShot(i).Shoot >= 100 Then
                gShot(i).Typ = 0
            End If
        End If
    Next i
    '###############Gegnerschieen Ende###################
            
    '###############Raketen Anfang###################
    For i = 49 To 53
        If Gedrckt(i) Then
            RaketenAuswahl = i - 48
        End If
    Next i
    
    If RaketenPause > 0 Then RaketenPause = RaketenPause + ((30 / FPS_Current) * Primary.Frequency)
    If RaketenPause >= RaketenNachladen Then RaketenPause = 0
    
    If Gedrckt(17) And RaketenPause = 0 And s_RaketenSlot(RaketenAuswahl - 1) > 0 Then
        Buffer = Int(Rnd * 2)
        DSRocket(Buffer).SetCurrentPosition 0
        DSRocket(Buffer).Play DSBPLAY_DEFAULT
        Shoted = Shoted + 1
        RaketenPause = 1
        s_RaketenSlot(RaketenAuswahl - 1) = s_RaketenSlot(RaketenAuswahl - 1) - 1
        For i = 0 To 20
            If Rakete(i).Typ = 0 Then
                Rakete(i).X = Player.X
                Rakete(i).Y = Player.Y    'Schussposition
                Rakete(i).Z = Player.Z
                For j = 0 To 50
                    If Gegner(j).Typ <> 0 And Gegner(j).Z <= Player.Z And Gegner(j).Z >= Player.Z - 100 Then
                         test = True
                         For k = 0 To 20
                            If Rakete(k).Victim = j Then
                                test = False
                            End If
                         Next k
                         If test = True Then
                            Rakete(i).Victim = j
                         End If
                    End If
                Next j
                Rakete(i).Typ = RaketenAuswahl
                Rakete(i).Power = 10 'TESTWERTE
                Rakete(i).Shoot = 1
                Exit For
            End If
        Next i
    End If
    For i = 0 To 20
        If Rakete(i).Typ = 1 Then
            Rakete(i).Z = Rakete(i).Z - (30 / FPS_Current) * 0.7
            Rakete(i).Shoot = Rakete(i).Shoot + (30 / FPS_Current) * 0.25
            If Rakete(i).Shoot >= 100 Then
                Rakete(i).Typ = 0
            End If
        End If
        If Rakete(i).Typ = 2 Then
            Rakete(i).Z = Rakete(i).Z - (30 / FPS_Current) * 0.7
            Rakete(i).Shoot = Rakete(i).Shoot + (30 / FPS_Current) * 0.5
            If Rakete(i).Shoot >= 50 Then
                Buffer = Int(Rnd * 3)
                DSShockwave(Buffer).SetCurrentPosition 0
                DSShockwave(Buffer).Play DSBPLAY_DEFAULT
                For j = 0 To 10
                    If Shockwave(j).Typ = 0 Then
                        Shockwave(j).Typ = 2
                        Shockwave(j).Gone = 1
                        Shockwave(j).X = Rakete(i).X
                        Shockwave(j).Y = Rakete(i).Y
                        Shockwave(j).Z = Rakete(i).Z
                        Exit For
                    End If
                Next j
                Rakete(i).Typ = 0
            End If
        End If
        If Rakete(i).Typ = 3 Then
            Rakete(i).Z = Rakete(i).Z - (30 / FPS_Current) * 0.7
            Rakete(i).Shoot = Rakete(i).Shoot + (30 / FPS_Current) * 0.5
            If Rakete(i).Shoot >= 50 Then
                Buffer = Int(Rnd * 3)
                DSShockwave(Buffer).SetCurrentPosition 0
                DSShockwave(Buffer).Play DSBPLAY_DEFAULT
                For j = 0 To 10
                    If Shockwave(j).Typ = 0 Then
                        Shockwave(j).Typ = 3
                        Shockwave(j).Gone = 1
                        Shockwave(j).X = Rakete(i).X
                        Shockwave(j).Y = Rakete(i).Y
                        Shockwave(j).Z = Rakete(i).Z
                        Exit For
                    End If
                Next j
                Rakete(i).Typ = 0
            End If
        End If
        If Rakete(i).Typ = 4 Then
            Rakete(i).Z = Rakete(i).Z - (30 / FPS_Current) * ((((Rakete(i).Z - Gegner(Rakete(i).Victim).Z)) / (Sqr(((Rakete(i).X - Gegner(Rakete(i).Victim).X)) ^ 2 + ((Rakete(i).Z - Gegner(Rakete(i).Victim).Z)) ^ 2)))) * 0.35
            Rakete(i).X = Rakete(i).X - (30 / FPS_Current) * ((((Rakete(i).X - Gegner(Rakete(i).Victim).X)) / (Sqr(((Rakete(i).X - Gegner(Rakete(i).Victim).X)) ^ 2 + ((Rakete(i).Z - Gegner(Rakete(i).Victim).Z)) ^ 2)))) * 0.35
            If Gegner(Rakete(i).Victim).Typ = 0 Then
                For j = 0 To 10
                    If Shockwave(j).Typ = 0 Then
                        Shockwave(j).Typ = 1
                        Shockwave(j).Gone = 1
                        Shockwave(j).X = Rakete(i).X
                        Shockwave(j).Y = Rakete(i).Y
                        Shockwave(j).Z = Rakete(i).Z
                        Rakete(i).Typ = 0
                        Exit For
                    End If
                Next j
            End If
        End If
        If Rakete(i).Typ = 5 Then
            Rakete(i).Z = Rakete(i).Z - (30 / FPS_Current) * 0.7
            Rakete(i).Shoot = Rakete(i).Shoot + (30 / FPS_Current) * 0.5
            If Rakete(i).Shoot >= 50 Then
                DSCluster.SetCurrentPosition 0
                DSCluster.Play DSBPLAY_DEFAULT
                'Int(Rnd * 2)
                k = 0
                For j = 0 To 100
                    If Shot(j).Typ = 0 Then
                        k = k + 1
                        Shot(j).X = Rakete(i).X
                        Shot(j).Y = Rakete(i).Y    'Schussposition
                        Shot(j).Z = Rakete(i).Z
                        Shot(j).vZ = (Rnd * 6) - 3
                        Shot(j).vY = 0  'Schussvektor
                        Shot(j).vX = (Rnd * 6) - 3
                        Shot(j).Typ = 1
                        Shot(j).Power = 4
                        Shot(j).Shoot = 0
                        Shot(j).Rotation = 0
                        If k >= 20 Then
                            Shoted = Shoted + 3
                            Exit For
                        End If
                    End If
                Next j
                Rakete(i).Typ = 0
            End If
        End If
        Rakete(i).Shoot = Rakete(i).Shoot + (30 / FPS_Current) * 0.4
        If Rakete(i).Shoot >= 100 Then
            Rakete(i).Typ = 0
        End If
    Next i
    '###############Raketen Ende###################
    
    '###############Kollision Anfang###################
    
    For i = 0 To 50
        If Gegner(i).Typ <> 0 And Player.Typ <> 0 Then
             If ((Gegner(i).X < Player.X + 1.2) And (Gegner(i).X > Player.X - 1.2)) And ((Gegner(i).Z < Player.Z + 2) And (Gegner(i).Z > Player.Z - 2)) Then
                If Player.Shild > 0 Then
                    Gegner(i).Typ = 0
                    Player.Shild = 0
                    For k = 0 To 10
                        If Explosion(k).Typ = 0 Then
                            Explosion(k).X = Gegner(i).X
                            Explosion(k).Y = Gegner(i).Y
                            Explosion(k).Z = Gegner(i).Z
                            Explosion(k).Gone = 0
                            Explosion(k).Typ = Int(Rnd * 3) + 1
                            Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                            Call Destroy_Berechnung(Auswahl, i)
                            Buffer = Int(Rnd * 5)
                            DSExplosion(Buffer).SetCurrentPosition 0
                            DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                            If k >= 4 Then Action = Action + 1
                            Exit For
                        End If
                    Next k
                Else
                    Gegner(i).Typ = 0
                    Player.Typ = 0
                    For k = 0 To 10
                        If Explosion(k).Typ = 0 Then
                            Explosion(k).X = Gegner(i).X
                            Explosion(k).Y = Gegner(i).Y
                            Explosion(k).Z = Gegner(i).Z
                            Explosion(k).Gone = 0
                            Explosion(k).Typ = Int(Rnd * 3) + 1
                            Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                            Buffer = Int(Rnd * 5)
                            DSExplosion(Buffer).SetCurrentPosition 0
                            DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                            If k >= 4 Then Action = Action + 1
                            Exit For
                        End If
                    Next k
                    For k = 0 To 10
                        If Explosion(k).Typ = 0 Then
                            Explosion(k).X = Player.X
                            Explosion(k).Y = Player.Y
                            Explosion(k).Z = Player.Z
                            Explosion(k).Gone = 0
                            Explosion(k).Typ = Int(Rnd * 3) + 1
                            Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                            Buffer = Int(Rnd * 5)
                            DSExplosion(Buffer).SetCurrentPosition 0
                            DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                            bTod = True
                            Ende = 1
                            Exit For
                        End If
                    Next k
                End If
             End If
        End If
    Next i
    
    
    
    For i = 0 To 100
        If gShot(i).Typ <> 0 And Player.Typ <> 0 Then
             If ((gShot(i).X < Player.X + 1.5) And (gShot(i).X > Player.X - 1.5)) And ((gShot(i).Z < Player.Z + 2.5) And (gShot(i).Z > Player.Z - 2.5)) Then
                If Player.Shild > 0 Then
                    Player.Shild = Player.Shild - 1
                Else
                    Player.Armor = Player.Armor - gShot(i).Power
                End If
                gShot(i).Typ = 0
                If Player.Armor <= 0 Then
                    Player.Typ = 0
                    For k = 0 To 10
                        If Explosion(k).Typ = 0 Then
                            Explosion(k).X = Player.X
                            Explosion(k).Y = Player.Y
                            Explosion(k).Z = Player.Z
                            Explosion(k).Gone = 0
                            Explosion(k).Typ = Int(Rnd * 3) + 1
                            Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                            Buffer = Int(Rnd * 5)
                            DSExplosion(Buffer).SetCurrentPosition 0
                            DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                            bTod = True
                            Ende = 1
                            Exit For
                        End If
                    Next k
                Else
                    For k = 0 To 10
                        If Treffer(k).Typ = 0 Then
                            Treffer(k).X = Player.X
                            Treffer(k).Y = Player.Y
                            Treffer(k).Z = Player.Z
                            Treffer(k).Gone = 0
                            Treffer(k).Typ = 1
                            Buffer = Int(Rnd * 4)
                            DSHit(Buffer).SetCurrentPosition 0
                            DSHit(Buffer).Play DSBPLAY_DEFAULT
                            If gShot(i).X <= Player.X Then
                                Treffer(k).Richtung = 1
                            Else
                                Treffer(k).Richtung = -1
                            End If
                            Exit For
                        End If
                    Next k
                End If
             End If
        End If
    Next i
    
    For i = 0 To 100
        If Shot(i).Typ <> 0 Then
            For j = 0 To 50
                If Gegner(j).Typ <> 0 And Gegner(j).Z <= Player.Z + 50 And Gegner(j).Z >= Player.Z - 100 Then
                    If Shot(i).Typ <> 3 Then
                        If ((Shot(i).X < Gegner(j).X + 1.5) And (Shot(i).X > Gegner(j).X - 1.5)) And ((Shot(i).Z < Gegner(j).Z + 2.5) And (Shot(i).Z > Gegner(j).Z - 2.5)) Then
                            Gegner(j).Armor = Gegner(j).Armor - Shot(i).Power
                            If Shot(i).X <= Gegner(j).X Then
                                Gegner(j).Vibration = Gegner(j).Vibration + 10
                            Else
                                Gegner(j).Vibration = Gegner(j).Vibration - 10
                            End If
                            Shot(i).Typ = 0
                            If Gegner(j).Armor <= 0 Then
                                Gegner(j).Typ = 0
                                For k = 0 To 10
                                    If Explosion(k).Typ = 0 Then
                                        Explosion(k).X = Gegner(j).X
                                        Explosion(k).Y = Gegner(j).Y
                                        Explosion(k).Z = Gegner(j).Z
                                        Explosion(k).Gone = 0
                                        Explosion(k).Typ = Int(Rnd * 3) + 1
                                        Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                                        Call Destroy_Berechnung(Auswahl, j)
                                        Hits = Hits + 1
                                        Buffer = Int(Rnd * 5)
                                        DSExplosion(Buffer).SetCurrentPosition 0
                                        DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                                        If k >= 4 Then Action = Action + 1
                                        Exit For
                                    End If
                                Next k
                            Else
                                For k = 0 To 10
                                    If Treffer(k).Typ = 0 Then
                                        Treffer(k).X = Gegner(j).X
                                        Treffer(k).Y = Gegner(j).Y
                                        Treffer(k).Z = Gegner(j).Z
                                        Treffer(k).Gone = 0
                                        Treffer(k).Typ = 1
                                        Buffer = Int(Rnd * 4)
                                        DSHit(Buffer).SetCurrentPosition 0
                                        DSHit(Buffer).Play DSBPLAY_DEFAULT
                                        If Shot(i).X <= Gegner(j).X Then
                                            Treffer(k).Richtung = 1
                                        Else
                                            Treffer(k).Richtung = -1
                                        End If
                                        Hits = Hits + 1
                                        Exit For
                                    End If
                                Next k
                            End If
                        End If
                    End If
                    
                    If Shot(i).Typ = 3 And Gegner(j).Z <= Player.Z + 50 And Gegner(j).Z >= Player.Z - 100 Then
                        If ((Shot(i).X < Gegner(j).X + 1.5) And (Shot(i).X > Gegner(j).X - 1.5)) And (Player.Z - Shot(i).Shoot <= Gegner(j).Z) And (Player.Z >= Gegner(j).Z) Then
                            Gegner(j).Armor = Gegner(j).Armor - Shot(i).Power
                            If Shot(i).X <= Gegner(j).X Then
                                Gegner(j).Vibration = Gegner(j).Vibration + 10
                            Else
                                Gegner(j).Vibration = Gegner(j).Vibration - 10
                            End If
                            Shot(i).Typ = 0
                            If Gegner(j).Armor <= 0 Then
                                Gegner(j).Typ = 0
                                For k = 0 To 10
                                    If Explosion(k).Typ = 0 Then
                                        Explosion(k).X = Gegner(j).X
                                        Explosion(k).Y = Gegner(j).Y
                                        Explosion(k).Z = Gegner(j).Z
                                        Explosion(k).Gone = 0
                                        Explosion(k).Typ = Int(Rnd * 3) + 1
                                        Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                                        Call Destroy_Berechnung(Auswahl, j)
                                        Hits = Hits + 1
                                        Buffer = Int(Rnd * 5)
                                        DSExplosion(Buffer).SetCurrentPosition 0
                                        DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                                        If k >= 4 Then Action = Action + 1
                                        Exit For
                                    End If
                                Next k
                            Else
                                For k = 0 To 10
                                    If Treffer(k).Typ = 0 Then
                                        Treffer(k).X = Gegner(j).X
                                        Treffer(k).Y = Gegner(j).Y
                                        Treffer(k).Z = Gegner(j).Z
                                        Treffer(k).Gone = 0
                                        Treffer(k).Typ = 1
                                        Buffer = Int(Rnd * 4)
                                        DSHit(Buffer).SetCurrentPosition 0
                                        DSHit(Buffer).Play DSBPLAY_DEFAULT
                                        If Shot(i).X <= Gegner(j).X Then
                                            Treffer(k).Richtung = 1
                                        Else
                                            Treffer(k).Richtung = -1
                                        End If
                                        Hits = Hits + 1
                                        Exit For
                                    End If
                                Next k
                            End If
                        End If
                    End If
                End If
            Next j
        End If
    Next i
    '-->##################Raketentreffer#####################
    For i = 0 To 20
        If Rakete(i).Typ <> 0 Then
            For j = 0 To 50
                If Gegner(j).Typ <> 0 Then
                    If ((Rakete(i).X < Gegner(j).X + 1.5) And (Rakete(i).X > Gegner(j).X - 1.5)) And ((Rakete(i).Z < Gegner(j).Z + 1.5) And (Rakete(i).Z > Gegner(j).Z - 1.5)) Then
                        Gegner(j).Armor = Gegner(j).Armor - Rakete(i).Power
                        Call Destroy_Berechnung(Auswahl, j)
                        If Rakete(i).Typ = 2 Or Rakete(i).Typ = 3 Then
                            For k = 0 To 10
                                If Shockwave(k).Typ = 0 Then
                                    Shockwave(k).Typ = Rakete(i).Typ
                                    Shockwave(k).Gone = 1
                                    Shockwave(k).X = Rakete(i).X
                                    Shockwave(k).Y = Rakete(i).Y
                                    Shockwave(k).Z = Rakete(i).Z
                                    Exit For
                                End If
                            Next k
                        End If
                        If Rakete(i).Typ = 5 Then
                            k = 0
                            For l = 0 To 100
                                If Shot(l).Typ = 0 Then
                                    k = k + 1
                                    Shot(l).X = Rakete(i).X
                                    Shot(l).Y = Rakete(i).Y    'Schussposition
                                    Shot(l).Z = Rakete(i).Z
                                    Shot(l).vZ = (Rnd * 6) - 3
                                    Shot(l).vY = 0  'Schussvektor
                                    Shot(l).vX = (Rnd * 6) - 3
                                    Shot(l).Typ = 1
                                    Shot(l).Power = 2
                                    Shot(l).Shoot = 0
                                    If k >= 20 Then Exit For
                                End If
                            Next l
                            Hits = Hits + 1
                            Rakete(i).Typ = 0
                        End If
                        Rakete(i).Typ = 0
                        If Gegner(j).Armor <= 0 Then
                            Gegner(j).Typ = 0
                            For k = 0 To 10
                                If Explosion(k).Typ = 0 Then
                                    Explosion(k).X = Gegner(j).X
                                    Explosion(k).Y = Gegner(j).Y
                                    Explosion(k).Z = Gegner(j).Z
                                    Explosion(k).Gone = 0
                                    Explosion(k).Typ = Int(Rnd * 3) + 1
                                    Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                                    Call Destroy_Berechnung(Auswahl, j)
                                    Buffer = Int(Rnd * 5)
                                    DSExplosion(Buffer).SetCurrentPosition 0
                                    DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                                    Hits = Hits + 1
                                    If k >= 4 Then Action = Action + 1
                                    Exit For
                                End If
                            Next k
                        End If
                    End If
                End If
            Next j
        End If
    Next i
    '-->############Raketentreffer#####################
    
    '-->##################Shockwavetreffer#####################
    For i = 0 To 10
        If Shockwave(i).Typ = 2 Then
            For j = 0 To 50
                If Gegner(j).Typ <> 0 Then
                    If Sqr((Gegner(j).X - Shockwave(i).X) ^ 2 + (Gegner(j).Z - Shockwave(i).Z) ^ 2) < Shockwave(i).Gone / 5 Then
                        Gegner(j).Typ = 0
                        For k = 0 To 10
                            If Explosion(k).Typ = 0 Then
                                Explosion(k).X = Gegner(j).X
                                Explosion(k).Y = Gegner(j).Y
                                Explosion(k).Z = Gegner(j).Z
                                Explosion(k).Gone = 0
                                Explosion(k).Typ = Int(Rnd * 3) + 1
                                Explosion(k).Blend = 3 'Int(Rnd * 2) + 2   '2
                                Call Destroy_Berechnung(Auswahl, j)
                                Buffer = Int(Rnd * 5)
                                DSExplosion(Buffer).SetCurrentPosition 0
                                DSExplosion(Buffer).Play DSBPLAY_DEFAULT
                                DSExplosion(Int(Rnd * 2)).Play DSBPLAY_DEFAULT
                                If k >= 4 Then Action = Action + 1
                                Exit For
                            End If
                        Next k
                    End If
                End If
            Next j
        End If
        If Shockwave(i).Typ = 3 Then
            For j = 0 To 50
                If Gegner(j).Typ <> 0 Then
                    If Sqr((Gegner(j).X - Shockwave(i).X) ^ 2 + (Gegner(j).Z - Shockwave(i).Z) ^ 2) < Shockwave(i).Gone / 5 Then
                        If Gegner(j).Vibration <= 2 Then
                            If Shockwave(i).X <= Gegner(j).X Then
                                Buffer = Int(Rnd * 3)
                                DSEmp(Buffer).SetCurrentPosition 0
                                DSEmp(Buffer).Play DSBPLAY_DEFAULT
                                Gegner(j).Vibration = Gegner(j).Vibration + 20
                            Else
                                Buffer = Int(Rnd * 3)
                                DSEmp(Buffer).SetCurrentPosition 0
                                DSEmp(Buffer).Play DSBPLAY_DEFAULT
                                Gegner(j).Vibration = Gegner(j).Vibration + 20
                            End If
                        End If
                    End If
                End If
            Next j
        End If
    Next i
    '-->############Shockwavetreffer#####################
    
    '###############Kollision Ende###################
    
    '###############Explosion Anfang###################
    For i = 0 To 10
        If Explosion(i).Typ <> 0 And Explosion(i).Gone < 100 Then
            Explosion(i).Gone = Explosion(i).Gone + (30 / FPS_Current)
        Else
            Explosion(i).Typ = 0
        End If
    Next i
    '###############Explosion Ende#####################
    
    '###############Shockwave Anfang###################
    For i = 0 To 10
        If Shockwave(i).Typ <> 0 And Shockwave(i).Gone < 100 Then
            Shockwave(i).Gone = Shockwave(i).Gone + (30 / FPS_Current) * 1
        Else
            Shockwave(i).Typ = 0
        End If
    Next i
    '###############Shockwave Ende#####################
    
    '###############Treffer Anfang###################
    For i = 0 To 10
        If Treffer(i).Typ <> 0 And Treffer(i).Gone <= 100 Then
            Treffer(i).Gone = Treffer(i).Gone + (30 / FPS_Current)
        Else
            Treffer(i).Typ = 0
        End If
    Next i
    '###############Treffer Ende#####################
    
    '###############Endetimer Ende#####################
    If Ende > 0 Then
        Ende = Ende + (30 / FPS_Current)
    End If
    If Ende > 15 Then
        bSieg = True
    End If
    '###############Endetimer Ende#####################
     
End Sub

Public Sub Destroy_Berechnung(Auswahl As String, i As Integer)
    
    If s_Schwierigkeitsgrad = "schwer" Then
        Gegner(i).Armorsave = Gegner(i).Armorsave / 1.5
    ElseIf s_Schwierigkeitsgrad = "mittel" Then
        Gegner(i).Armorsave = Gegner(i).Armorsave / 1
    ElseIf s_Schwierigkeitsgrad = "leicht" Then
        Gegner(i).Armorsave = Gegner(i).Armorsave / 0.5
    ElseIf s_Schwierigkeitsgrad = "massaker" Then
        Gegner(i).Armorsave = 1
    End If
    
    If Auswahl = "level1" Then
        If Gegner(i).Armorsave = 1 Then
            DestroyedEnemy = DestroyedEnemy + 0.7
        ElseIf Gegner(i).Armorsave = 2 Then
            DestroyedEnemy = DestroyedEnemy + 1
        ElseIf Gegner(i).Armorsave = 3 Then
            DestroyedEnemy = DestroyedEnemy + 1.3
        End If
    ElseIf Auswahl = "level2" Then
        If Gegner(i).Armorsave = 3 Then
            DestroyedEnemy = DestroyedEnemy + 0.9
        ElseIf Gegner(i).Armorsave = 4 Then
            DestroyedEnemy = DestroyedEnemy + 1.2
        ElseIf Gegner(i).Armorsave = 5 Then
            DestroyedEnemy = DestroyedEnemy + 1.5
        End If
        
        If Gegner(i).Armorsave = 1 Then
            DestroyedEnemy = DestroyedEnemy + 0.7
        End If
    ElseIf Auswahl = "level3" Then
        If Gegner(i).Armorsave = 5 Then
            DestroyedEnemy = DestroyedEnemy + 0.8
        ElseIf Gegner(i).Armorsave = 6 Then
            DestroyedEnemy = DestroyedEnemy + 1.1
        ElseIf Gegner(i).Armorsave = 7 Then
            DestroyedEnemy = DestroyedEnemy + 1.4
        End If
        
        If Gegner(i).Armorsave = 1 Then
            DestroyedEnemy = DestroyedEnemy + 0.9
        End If
    ElseIf Auswahl = "level4" Then
        If Gegner(i).Armorsave = 7 Then
            DestroyedEnemy = DestroyedEnemy + 1.2
        ElseIf Gegner(i).Armorsave = 8 Then
            DestroyedEnemy = DestroyedEnemy + 1.5
        ElseIf Gegner(i).Armorsave = 9 Then
            DestroyedEnemy = DestroyedEnemy + 1.8
        End If
        
        If Gegner(i).Armorsave = 1 Then
            DestroyedEnemy = DestroyedEnemy + 1.1
        End If
    ElseIf Auswahl = "level5" Then
        If Gegner(i).Armorsave = 9 Then
            DestroyedEnemy = DestroyedEnemy + 1.1
        ElseIf Gegner(i).Armorsave = 10 Then
            DestroyedEnemy = DestroyedEnemy + 1.4
        ElseIf Gegner(i).Armorsave = 11 Then
            DestroyedEnemy = DestroyedEnemy + 1.7
        End If
        
        If Gegner(i).Armorsave = 1 Then
            DestroyedEnemy = DestroyedEnemy + 1.3
        End If
    End If
    Destroyed = Destroyed + 1
    
    If s_Schwierigkeitsgrad = "schwer" Then
        Gegner(i).Armorsave = Gegner(i).Armorsave * 1.5
    ElseIf s_Schwierigkeitsgrad = "mittel" Then
        Gegner(i).Armorsave = Gegner(i).Armorsave * 1
    ElseIf s_Schwierigkeitsgrad = "leicht" Then
        Gegner(i).Armorsave = Gegner(i).Armorsave * 0.5
    ElseIf s_Schwierigkeitsgrad = "massaker" Then
        Gegner(i).Armorsave = 1
    End If
End Sub
