Attribute VB_Name = "Geometry"
Option Explicit

Public VBuffer As Direct3DVertexBuffer8
Public VBuffer_Background As Direct3DVertexBuffer8
Public VBuffer_Frontground As Direct3DVertexBuffer8
Public VBuffer_Ground(255) As Direct3DVertexBuffer8
Public VBuffer_Button_Start(255) As Direct3DVertexBuffer8
Public VBuffer_Button_Main(255) As Direct3DVertexBuffer8
Public VBuffer_Credits(255) As Direct3DVertexBuffer8
Public VBuffer_Frontground_shop1(255) As Direct3DVertexBuffer8
Public VBuffer_Frontground_shop2(255) As Direct3DVertexBuffer8

Public DSSound As DirectSoundSecondaryBuffer8
Public DSClick As DirectSoundSecondaryBuffer8
Public DSExplosion(5) As DirectSoundSecondaryBuffer8
Public DSCluster As DirectSoundSecondaryBuffer8
Public DSDrift(1) As DirectSoundSecondaryBuffer8
Public DSEmp(2) As DirectSoundSecondaryBuffer8
Public DSEnergiediskus As DirectSoundSecondaryBuffer8
Public DSGun As DirectSoundSecondaryBuffer8
Public DSHit(4) As DirectSoundSecondaryBuffer8
Public DSLaser As DirectSoundSecondaryBuffer8
Public DSLaserkatapult As DirectSoundSecondaryBuffer8
Public DSPlasma As DirectSoundSecondaryBuffer8
Public DSRocket(1) As DirectSoundSecondaryBuffer8
Public DSShockwave(3) As DirectSoundSecondaryBuffer8
Public DSTurbine As DirectSoundSecondaryBuffer8

Public Frontground(90) As LITVERTEX
Public Background(90) As LITVERTEX
Public Button(5) As LITVERTEX
Public Credit(5) As LITVERTEX
Public Ground(5) As LITVERTEX

Public Texture_Frontground_Start As Direct3DTexture8
Public Texture_Background_Start As Direct3DTexture8
Public Texture_Frontground_Main As Direct3DTexture8
Public Texture_Background_Main As Direct3DTexture8
Public Texture_Button_Start(9) As Direct3DTexture8
Public Texture_Front(10) As Direct3DTexture8
Public Texture_Credits(6) As Direct3DTexture8
Public Texture_Button_Main(15) As Direct3DTexture8
Public Texture_Credits_Shop(6) As Direct3DTexture8
Public Texture_Frontground_Shop As Direct3DTexture8
Public Texture_Loading As Direct3DTexture8
Public Texture_Loading2 As Direct3DTexture8
Public Texture_Background_Shop As Direct3DTexture8
Public Texture_Front_Shop(1, 2, 6) As Direct3DTexture8
Public Texture_Extras_Shop(-1 To 7) As Direct3DTexture8
Public Texture_Extras_gross_Shop(-1 To 7) As Direct3DTexture8

Public TextRect As RECT
Public MainFont As D3DXFont
Public MainFontDesc As IFont
Public fnt As New StdFont

Public Function InitialiseGeometry() As Boolean
    
    On Error GoTo BailOut:
    
    Dim i As Integer, j As Single, Buffer As Integer
    
    '################################Text Anfang###################################
    TextRect.Top = 0
    TextRect.bottom = 20
    TextRect.Right = 75
    fnt.Name = "Arial"
    fnt.Size = 12
    Set MainFontDesc = fnt
    Set MainFont = D3DX.CreateFont(D3DDevice, MainFontDesc.hFont)
    
    Set Texture_Loading = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\hangar.jpg", 640, 480, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Loading2 = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\hangar2.jpg", 640, 480, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    Call CreateFrontGround(0, 0, 2, 30, 177)
    
    Render_Load ("Loading...")
    '################################Text Anfang###################################
    
    '################################Vertices Anfang###################################
    For i = 0 To 255
        Button(0) = CreateLitVertex(2.6, 8, 100, RGB(i, i / 2, i / 2), 0, 1, 1)
        Button(1) = CreateLitVertex(5.6, 9, 100, RGB(i, i / 2, i / 2), 0, 0, 0)
        Button(2) = CreateLitVertex(2.6, 9, 100, RGB(i, i / 2, i / 2), 0, 1, 0)
        Button(3) = CreateLitVertex(5.6, 9, 100, RGB(i, i / 2, i / 2), 0, 0, 0)
        Button(4) = CreateLitVertex(2.6, 8, 100, RGB(i, i / 2, i / 2), 0, 1, 1)
        Button(5) = CreateLitVertex(5.6, 8, 100, RGB(i, i / 2, i / 2), 0, 0, 1)
        
        Set VBuffer_Button_Start(i) = D3DDevice.CreateVertexBuffer(Len(Button(0)) * 6, 0, Lit_FVF, D3DPOOL_DEFAULT)
        D3DVertexBuffer8SetData VBuffer_Button_Start(i), 0, Len(Button(0)) * 6, 0, Button(0)
    Next i
    
    For i = 0 To 255
        Button(0) = CreateLitVertex(3.1, 8, 100, RGB(i, i / 2, i / 2), 0, 1, 1)
        Button(1) = CreateLitVertex(5.1, 9, 100, RGB(i, i / 2, i / 2), 0, 0, 0)
        Button(2) = CreateLitVertex(3.1, 9, 100, RGB(i, i / 2, i / 2), 0, 1, 0)
        Button(3) = CreateLitVertex(5.1, 9, 100, RGB(i, i / 2, i / 2), 0, 0, 0)
        Button(4) = CreateLitVertex(3.1, 8, 100, RGB(i, i / 2, i / 2), 0, 1, 1)
        Button(5) = CreateLitVertex(5.1, 8, 100, RGB(i, i / 2, i / 2), 0, 0, 1)
        
        Set VBuffer_Button_Main(i) = D3DDevice.CreateVertexBuffer(Len(Button(0)) * 6, 0, Lit_FVF, D3DPOOL_DEFAULT)
        D3DVertexBuffer8SetData VBuffer_Button_Main(i), 0, Len(Button(0)) * 6, 0, Button(0)
    Next i
    
    For i = 0 To 255
        Credit(0) = CreateLitVertex(1.7, 4, 100, RGB(i, i, i), 0, 1, 1)
        Credit(1) = CreateLitVertex(5.7, 6, 100, RGB(i, i, i), 0, 0, 0)
        Credit(2) = CreateLitVertex(1.7, 6, 100, RGB(i, i, i), 0, 1, 0)
        Credit(3) = CreateLitVertex(5.7, 6, 100, RGB(i, i, i), 0, 0, 0)
        Credit(4) = CreateLitVertex(1.7, 4, 100, RGB(i, i, i), 0, 1, 1)
        Credit(5) = CreateLitVertex(5.7, 4, 100, RGB(i, i, i), 0, 0, 1)
        
        Set VBuffer_Credits(i) = D3DDevice.CreateVertexBuffer(Len(Credit(0)) * 6, 0, Lit_FVF, D3DPOOL_DEFAULT)
        D3DVertexBuffer8SetData VBuffer_Credits(i), 0, Len(Credit(0)) * 6, 0, Credit(0)
    Next i
    
    For i = 0 To 255
        Ground(0) = CreateLitVertex(-4, -5, 100, RGB(i, i, i), 0, 1, 1)
        Ground(1) = CreateLitVertex(4, 5, 100, RGB(i, i, i), 0, 0, 0)
        Ground(2) = CreateLitVertex(-4, 5, 100, RGB(i, i, i), 0, 1, 0)
        Ground(3) = CreateLitVertex(4, 5, 100, RGB(i, i, i), 0, 0, 0)
        Ground(4) = CreateLitVertex(-4, -5, 100, RGB(i, i, i), 0, 1, 1)
        Ground(5) = CreateLitVertex(4, -5, 100, RGB(i, i, i), 0, 0, 1)
            
        Set VBuffer_Ground(i) = D3DDevice.CreateVertexBuffer(Len(Ground(0)) * 6, 0, Lit_FVF, D3DPOOL_DEFAULT)
        D3DVertexBuffer8SetData VBuffer_Ground(i), 0, Len(Ground(0)) * 6, 0, Ground(0)
    Next i
    
    For i = 0 To 255
        Ground(0) = CreateLitVertex(-3.1, 5.2, 100, RGB(i, i, i), 0, 1, 1)
        Ground(1) = CreateLitVertex(3.1, 9.5, 100, RGB(i, i, i), 0, 0, 0)
        Ground(2) = CreateLitVertex(-3.1, 9.5, 100, RGB(i, i, i), 0, 1, 0)
        Ground(3) = CreateLitVertex(3.1, 9.5, 100, RGB(i, i, i), 0, 0, 0)
        Ground(4) = CreateLitVertex(-3.1, 5.2, 100, RGB(i, i, i), 0, 1, 1)
        Ground(5) = CreateLitVertex(3.1, 5.2, 100, RGB(i, i, i), 0, 0, 1)
                
        Set VBuffer_Frontground_shop1(i) = D3DDevice.CreateVertexBuffer(Len(Ground(0)) * 6, 0, Lit_FVF, D3DPOOL_DEFAULT)
        D3DVertexBuffer8SetData VBuffer_Frontground_shop1(i), 0, Len(Ground(0)) * 6, 0, Ground(0)
    Next i
   
    For i = 0 To 255
        Ground(0) = CreateLitVertex(-1#, 5.3, 100, RGB(i, i, i), 0, 1, 1)
        Ground(1) = CreateLitVertex(1#, 9.4, 100, RGB(i, i, i), 0, 0, 0)
        Ground(2) = CreateLitVertex(-1#, 9.4, 100, RGB(i, i, i), 0, 1, 0)
        Ground(3) = CreateLitVertex(1#, 9.4, 100, RGB(i, i, i), 0, 0, 0)
        Ground(4) = CreateLitVertex(-1#, 5.3, 100, RGB(i, i, i), 0, 1, 1)
        Ground(5) = CreateLitVertex(1#, 5.3, 100, RGB(i, i, i), 0, 0, 1)
                   
        Set VBuffer_Frontground_shop2(i) = D3DDevice.CreateVertexBuffer(Len(Ground(0)) * 6, 0, Lit_FVF, D3DPOOL_DEFAULT)
        D3DVertexBuffer8SetData VBuffer_Frontground_shop2(i), 0, Len(Ground(0)) * 6, 0, Ground(0)
    Next i
    '################################Vertices Anfang###################################

    '################################Textures Anfang###################################
    Set Texture_Background_Start = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cas7.jpg ", 1024, 768, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Frontground_Start = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\startbackround.jpg", 1024, 768, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Start(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Neues Spiel.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Start(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Spiel laden.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Start(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\multiplayer.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Start(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\empty.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Start(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Beenden.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)

    Set Texture_Background_Main = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cas5.jpg", 1024, 768, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Frontground_Main = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\MainMenu.jpg", 640, 480, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Button_Main(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\start.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\story.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\shop.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\speichern.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\empty.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\laden.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(6) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\empty.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(7) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\empty.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(8) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\support.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Button_Main(9) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\end.jpg", 99, 36, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground1.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground2.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground3.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground4.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground5.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground6.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(6) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground7.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(7) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground8.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(8) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground9.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(9) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground10.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front(10) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\ground11.jpg", 500, 500, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    Set Texture_Credits(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cre7.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Credits(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cre6.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Credits(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cre5.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Credits(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cre4.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Credits(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cre3.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Credits(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cre2.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Credits(6) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cre1.jpg", 166, 45, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    Set Texture_Background_Shop = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\cas5.jpg ", 640, 480, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Frontground_Shop = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\shopstore.jpg", 1024, 768, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    Set Texture_Front_Shop(0, 0, 0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box000.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 0, 1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box001.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 0, 2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box002.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 0, 3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box003.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 0, 4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box004.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    Set Texture_Front_Shop(0, 1, 0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box010.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 1, 1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box011.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 1, 2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box012.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 1, 3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box013.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 1, 4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box014.jpg", 200, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(1, 1, 0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box050.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(1, 1, 1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box051.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(1, 1, 2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box052.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(1, 1, 3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box053.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(1, 1, 4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box054.jpg", 200, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    
    Set Texture_Front_Shop(0, 2, 0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box020.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 2, 1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box021.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 2, 2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box022.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 2, 3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box023.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Front_Shop(0, 2, 4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box024.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    Set Texture_Front_Shop(1, 2, 0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box120.jpg", 200, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    'Rocketdeck
    
    Set Texture_Extras_Shop(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box2.jpg", 200, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    'Extrasdeck
    
    Set Texture_Extras_Shop(-1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box1.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_Shop(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box040.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_Shop(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box041.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_Shop(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box042.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_Shop(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box043.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_Shop(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box044.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_Shop(6) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box045.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_Shop(7) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box046.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    Set Texture_Extras_gross_Shop(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box030.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_gross_Shop(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box031.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_gross_Shop(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box032.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_gross_Shop(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box033.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_gross_Shop(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box034.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_gross_Shop(6) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box035.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras_gross_Shop(7) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box036.jpg", 300, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    
    '--------------------------------------levels
    
    Set Texture(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\soil_grass.jpg", 512, 512, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\eis.jpg", 640, 480, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\wste.jpg", 640, 480, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\nebel1.jpg", 1024, 768, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\sterne.jpg", 1024, 768, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture2 = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\wasser.jpg", 256, 256, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture3 = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\grass.bmp", 32, 20, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_himmel = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\himmel_rechts.jpg", 256, 129, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_menue = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\statusleiste.bmp", 240, 768, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_menue2 = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\statuskasten_lu.bmp", 240, 768, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_neigung = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\neigungsmesser.bmp", 75, 75, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_energy(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\energiediskus_stufe1.bmp", 134, 139, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_energy(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\energiediskus_stufe2.bmp", 134, 139, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_energy(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\energiediskus_stufe3.bmp", 134, 139, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_energy(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\energiediskus_stufe4.bmp", 134, 139, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_energy(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\energiediskus_stufe5.bmp", 134, 139, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_energy(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\energiediskus_stufe6.bmp", 134, 139, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Shockwave = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\shockwave3.jpg", 214, 213, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Shot(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Particle.jpg", 88, 91, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Shot(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Particle.jpg", 88, 91, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Shot(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Particle.jpg", 88, 91, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Shot(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\shockwave3.jpg", 88, 91, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Shot(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Particle.jpg", 88, 91, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Shot(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\Particle.jpg", 88, 91, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    
    Set Texture_Pause(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\pausenkasten1.bmp", 240, 768, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Pause(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\pausenkasten2.bmp", 240, 768, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Pause(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\pausenkasten3.bmp", 240, 768, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_stats = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\statskasten.bmp", 300, 337, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
           
    Set Texture_Weapon(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\p_plasmakanone.jpg", 160, 50, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Weapon(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\p_laserschuss.jpg", 160, 50, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Weapon(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\p_laserstrahl.jpg", 160, 50, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Weapon(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\p_energiediskus.jpg", 160, 50, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture_Weapon(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\p_standmg.jpg", 160, 50, D3DX_DEFAULT, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    
    Set Texture_Extras(-1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box1.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(0) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box2.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(1) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box040.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(2) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box041.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(3) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box042.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(4) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box043.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(5) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box044.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(6) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box045.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    Set Texture_Extras(7) = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\gfx\box046.jpg", 100, 200, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, &HFFFF00FF, ByVal 0, ByVal 0)
    '################################Textures Ende###################################
    
    '################################Sounds Anfang###################################
    Set DSClick = DS.CreateSoundBufferFromFile(App.Path & "\sfx\click.wav", DSBDesc)
    Set DSCluster = DS.CreateSoundBufferFromFile(App.Path & "\sfx\cluster.wav", DSBDesc)
    Set DSDrift(0) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\drift1.wav", DSBDesc)
    Set DSDrift(1) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\drift2.wav", DSBDesc)
    Set DSEmp(0) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\emp1.wav", DSBDesc)
    Set DSEmp(1) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\emp2.wav", DSBDesc)
    Set DSEmp(2) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\emp3.wav", DSBDesc)
    Set DSEnergiediskus = DS.CreateSoundBufferFromFile(App.Path & "\sfx\energiediskus1.wav", DSBDesc)
    Set DSExplosion(0) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\explosion1.wav", DSBDesc)
    Set DSExplosion(1) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\explosion2.wav", DSBDesc)
    Set DSExplosion(2) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\explosion3.wav", DSBDesc)
    Set DSExplosion(3) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\explosion4.wav", DSBDesc)
    Set DSExplosion(4) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\explosion5.wav", DSBDesc)
    Set DSExplosion(5) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\explosion6.wav", DSBDesc)
    Set DSGun = DS.CreateSoundBufferFromFile(App.Path & "\sfx\gun1.wav", DSBDesc)
    Set DSHit(0) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\hit1.wav", DSBDesc)
    Set DSHit(1) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\hit2.wav", DSBDesc)
    Set DSHit(2) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\hit3.wav", DSBDesc)
    Set DSHit(3) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\hit4.wav", DSBDesc)
    Set DSHit(4) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\hit5.wav", DSBDesc)
    Set DSLaser = DS.CreateSoundBufferFromFile(App.Path & "\sfx\laser1.wav", DSBDesc)
    Set DSLaserkatapult = DS.CreateSoundBufferFromFile(App.Path & "\sfx\laserkatapult1.wav", DSBDesc)
    Set DSPlasma = DS.CreateSoundBufferFromFile(App.Path & "\sfx\plasma1.wav", DSBDesc)
    Set DSRocket(0) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\rocket1.wav", DSBDesc)
    Set DSRocket(1) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\rocket2.wav", DSBDesc)
    Set DSShockwave(0) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\shockwave1.wav", DSBDesc)
    Set DSShockwave(1) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\shockwave2.wav", DSBDesc)
    Set DSShockwave(2) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\shockwave3.wav", DSBDesc)
    Set DSShockwave(3) = DS.CreateSoundBufferFromFile(App.Path & "\sfx\shockwave4.wav", DSBDesc)
    Set DSTurbine = DS.CreateSoundBufferFromFile(App.Path & "\sfx\turbine1.wav", DSBDesc)
    '################################Sounds Ende###################################

    '################################Soundvolume Anfang###################################
    If Configs(4) = "Leise" Then Buffer = -2200
    If Configs(4) = "Normal" Then Buffer = -1100
    If Configs(4) = "Laut" Then Buffer = 0
    DSClick.SetVolume Buffer
    DSCluster.SetVolume Buffer
    DSDrift(0).SetVolume Buffer
    DSDrift(1).SetVolume Buffer
    DSEmp(0).SetVolume Buffer
    DSEmp(1).SetVolume Buffer
    DSEmp(2).SetVolume Buffer
    DSEnergiediskus.SetVolume Buffer
    DSExplosion(0).SetVolume Buffer
    DSExplosion(1).SetVolume Buffer
    DSExplosion(2).SetVolume Buffer
    DSExplosion(3).SetVolume Buffer
    DSExplosion(4).SetVolume Buffer
    DSExplosion(5).SetVolume Buffer
    DSGun.SetVolume Buffer
    DSHit(0).SetVolume Buffer
    DSHit(1).SetVolume Buffer
    DSHit(2).SetVolume Buffer
    DSHit(3).SetVolume Buffer
    DSHit(4).SetVolume Buffer
    DSLaser.SetVolume Buffer
    DSLaserkatapult.SetVolume Buffer
    DSPlasma.SetVolume Buffer
    DSRocket(0).SetVolume Buffer
    DSRocket(1).SetVolume Buffer
    DSShockwave(0).SetVolume Buffer
    DSShockwave(1).SetVolume Buffer
    DSShockwave(2).SetVolume Buffer
    DSShockwave(3).SetVolume Buffer
    DSTurbine.SetVolume (Buffer - 1100)
    '################################Soundvolume Ende###################################

    InitialiseGeometry = True
Exit Function
BailOut:
InitialiseGeometry = False
End Function

Public Sub CreateFrontGround(move As Single, Wellenhhe As Single, Lnge As Single, Breite As Single, Helligkeit As Single)
    On Error GoTo BailOut:
    
    Dim X As Single
            
    For X = -15 To 15
        Frontground((X + 15) * 2 + 0) = CreateLitVertex(X * Lnge, Sin(X + move) * Wellenhhe _
            , Breite, RGB(Helligkeit, Helligkeit, Helligkeit), 0, ((X + 15) / 30), 1)
        Frontground((X + 15) * 2 + 1) = CreateLitVertex(X * Lnge, Sin(X + move) * Wellenhhe _
            , -Breite, RGB(Helligkeit, Helligkeit, Helligkeit), 0, ((X + 15) / 30), 0)
    Next X
        
    Set VBuffer_Frontground = D3DDevice.CreateVertexBuffer(Len(Frontground(0)) * 120, 0, Lit_FVF, D3DPOOL_DEFAULT)
    D3DVertexBuffer8SetData VBuffer_Frontground, 0, Len(Frontground(0)) * 120, 0, Frontground(0)

BailOut:
Exit Sub
End Sub

Public Sub CreateBackGround(move As Single, Wellenhhe As Single, Lnge As Single, Breite As Single, Helligkeit As Single)
    On Error GoTo BailOut:
    
    Dim X As Single
            
    For X = -15 To 15
        Background((X + 15) * 2 + 0) = CreateLitVertex(X * Lnge, Sin(X + move) * Wellenhhe _
            , Breite, RGB(Helligkeit, Helligkeit, Helligkeit), 0, ((X + 15) / 30), 1)
        Background((X + 15) * 2 + 1) = CreateLitVertex(X * Lnge, Sin(X + move) * Wellenhhe _
            , -Breite, RGB(Helligkeit, Helligkeit, Helligkeit), 0, ((X + 15) / 30), 0)
    Next X
    
    Set VBuffer_Background = D3DDevice.CreateVertexBuffer(Len(Background(0)) * 120, 0, Lit_FVF, D3DPOOL_DEFAULT)
    D3DVertexBuffer8SetData VBuffer_Background, 0, Len(Background(0)) * 120, 0, Background(0)
    
BailOut:
Exit Sub
End Sub

